#include<stdbool.h>
#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#define g 9.82
#define pi 3.14

/*Henter inputdata*/
extern float L[13],Ls[4],A[13],As[4],Rh[13],rh[4],Asjakt[4];
extern float fmodell,sjakttyp,Qn,Q0,Q0bekk,a,Tl,Tavslag,Tpadrag,dt,tmax,H0,Hturb,Hu,dx,simtyp;
extern _Bool S1,S2,S3,S4,Bekk,FLsjakt;
extern float Kstilling (float t, float Tl, float Tavslag, float Tpadrag, float simtyp);

float fq(float A, float Dh, float Q)					//Kvasilikevekt friksjonsfaktor
{	float fq;
	float Re = (998*(fabs(Q)/A)*Dh)/0.001002;
	if(Re<10)
	{	Re=10;	}
	if (Re<2300)
	{	fq=64/Re;}
	else
	{	fq = pow(1/(-1.8*log10f(pow(0.0009/3.7,1.11)+(6.9/Re))),2);	}		//Quasi-steady friksjonsfaktor
																			//e/D=0,0383, basert p Manningstall p 33
																			//e/D=0,0009 basert p Manningstall p 60
	return fq;

}
float Arealsjakt(float Z)
{	float Arealsjakt;
	if(sjakttyp==3)				//Svingesjakt Frland
	{
		float Bhus=8;
		float Lhus=15;

		if(Z<=170)
		{	Arealsjakt=7.07;	}
		else if(Z>170 && Z<199)
		{	Arealsjakt=63.6;	}
		else if(Z>=199 && Z<201)
		{	Arealsjakt=63.6+((((Bhus*Lhus)-63.6)/(201-199))*(Z-199));	}
		else if(Z>=201)
		{	Arealsjakt=Bhus*Lhus;	}
	}
	else if(sjakttyp==2)			//Svingesjakt Aldal
	{
		if(Z<203)
		{	Arealsjakt=102;	}
	//	else if(Z>=178 && Z<188)
	//	{	Arealsjakt=212.14;}//+(	(10-(Z-180))/tan(11.3*(pi/180))	);	}
	//	else if(Z>=185 && Z<1039)
	//	{	Arealsjakt=28.27;	}
		else
		{	Arealsjakt=400;	}
	}
	else if(sjakttyp==1)			//Normal svingesjakt
	{	if(S3==1)
		{	Arealsjakt=Asjakt[3];	}
		else
		{	Arealsjakt=Asjakt[1];	}
	}
	else if(sjakttyp==4)
	{
		if(Z<=178)
		{	if(S3==1)
			{	Arealsjakt=Asjakt[3];	}
			else
			{	Arealsjakt=Asjakt[1];	}
		}
		else if(Z>178 && Z<189)
		{	Arealsjakt=212.13;			}
		else
		{	if(S3==1)
			{	Arealsjakt=Asjakt[3];	}
			else
			{	Arealsjakt=Asjakt[1];	}
		}
	}
	return Arealsjakt;
}

float f=0.064;


int main(void)
{
	input();

int I2=L[2]/dx,I1=L[1]/dx,Is1=Ls[1]/dx,I3=L[3]/dx,I4=L[4]/dx,I5=L[5]/dx,I9=L[9]/dx,I10=L[10]/dx,I6=L[6]/dx,I7=L[7]/dx,I8=L[8]/dx,Is2=Ls[2]/dx,Is3=Ls[3]/dx;		//Antall xsteg
int I11=L[11]/dx,I12=L[12]/dx;
int T=tmax/dt;

/*Definerer resultatmatriser. */
	float HL1[1][I1],HL1ny[1][I1];
	float QL1[1][I1],QL1ny[1][I1];
	float J1[1][I1],J1ny[1][I1];
	float HL2[1][I2],HL2ny[1][I2];
	float QL2[1][I2],QL2ny[1][I2];
	float J2[1][I2],J2ny[1][I2];
	float HL3[1][I3],HL3ny[1][I3];
	float QL3[1][I3],QL3ny[1][I3];
	float J3[1][I3],J3ny[1][I3];
	float HL4[1][I4],HL4ny[1][I4];
	float QL4[1][I4],QL4ny[1][I4];
	float J4[1][I4],J4ny[1][I4];
	float HL5[1][I5],HL5ny[1][I5];
	float QL5[1][I5],QL5ny[1][I5];
	float J5[1][I5],J5ny[1][I5];
	float HL6[1][I6],HL6ny[1][I6];
	float QL6[1][I6],QL6ny[1][I6];
	float J6[1][I6],J6ny[1][I6];
	float HL7[1][I7],HL7ny[1][I7];
	float QL7[1][I7],QL7ny[1][I7];
	float J7[1][I7],J7ny[1][I7];
	float HL8[1][I8],HL8ny[1][I8];
	float QL8[1][I8],QL8ny[1][I8];
	float J8[1][I8],J8ny[1][I8];
	float HL9[1][I9],HL9ny[1][I9];
	float QL9[1][I9],QL9ny[1][I9];
	float J9[1][I9],J9ny[1][I9];
	float HL10[1][I10],HL10ny[1][I10];
	float QL10[1][I10],QL10ny[1][I10];
	float J10[1][I10],J10ny[1][I10];
	float HL11[1][I11],HL11ny[1][I11];
	float QL11[1][I11],QL11ny[1][I11];
	float J11[1][I11],J11ny[1][I11];
	float HL12[1][I12],HL12ny[1][I12];
	float QL12[1][I12],QL12ny[1][I12];
	float J12[1][I12],J12ny[1][I12];
	float HLs1[1][Is1],HLs1ny[1][Is1];
	float QLs1[1][Is1],QLs1ny[1][Is1];
	float Js1[1][Is1],Js1ny[1][Is1];
	float HLs2[1][Is2],HLs2ny[1][Is2];
	float QLs2[1][Is2],QLs2ny[1][Is2];
	float Js2[1][Is2],Js2ny[1][Is2];
	float HLs3[1][Is3],HLs3ny[1][Is3];
	float QLs3[1][Is3],QLs3ny[1][Is3];
	float Js3[1][Is3],Js3ny[1][Is3];

	float Z1,Hj,kk,Z2,Z3;

	/*pner resultatfiler*/
		remove("resultatH.txt");
		FILE *resultatH;
		resultatH = fopen("resultatH.txt","a");
		remove("resultatQ.txt");
		FILE *resultatQ;
		resultatQ = fopen("resultatQ.txt","a");
		remove("resultatZ1.txt");
		FILE *resultatZ1;
		resultatZ1 = fopen("resultatZ1.txt","a");
		remove("resultatZ3.txt");
		FILE *resultatZ3;
		resultatZ3 = fopen("resultatZ3.txt","a");
		remove("resultatZ2.txt");
		FILE *resultatZ2;
		resultatZ2 = fopen("resultatZ2.txt","a");
		remove("Kstil.txt");
		FILE *Kstil;
		Kstil = fopen("Kstil.txt","a");
		remove("resultatHp.txt");
		FILE *resultatHp;
		resultatHp = fopen("resultatHp.txt","a");

if(Bekk==0)
{	Q0bekk=0;	}

	float t,x;

	/*Initelle verdier*/
	int i1=0,i2=0,i3=0,is1=0,i4=0,i5=0,i9=0,i10=0,i6=0,i7=0,i8=0,is2=0,is3=0,i11=0,i12=0;


	for (i1=0;i1<=I1;i1++)
	{	QL1[0][i1]=Q0-Q0bekk;
		if(fmodell==1)
		{	HL1[0][i1]=H0-((f*Q0*Q0*i1*dx)/(A[1]*A[1]*4*Rh[1]*2*g));
			J1[0][i1]=0;	}
		if(fmodell==2)
		{	HL1[0][i1]=H0-((fq(A[1],4*Rh[1],Q0-Q0bekk)*Q0*Q0*i1*dx)/(A[1]*A[1]*4*Rh[1]*2*g));
			J1[0][i1]=0;	}
		if(fmodell==3)
		{	HL1[0][i1]=H0-((fq(A[1],4*Rh[1],Q0-Q0bekk)*(Q0-Q0bekk)*(Q0-Q0bekk)*i1*dx)/(A[1]*A[1]*4*Rh[1]*2*g));
			J1[0][i1]=(dx*fq(A[1],4*Rh[1],(Q0-Q0bekk))*(Q0-Q0bekk)*(Q0-Q0bekk))/(A[1]*A[1]*4*Rh[1]*2*g*g);	}
		x=x+dx;					}

	for (i2=0;i2<=I2;i2++)
	{	QL2[0][i2]=Q0;
		if(fmodell==1)
		{	HL2[0][i2]=HL1[0][I1]-((f*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J2[0][i2]=0;	}
		if(fmodell==2)
		{	HL2[0][i2]=HL1[0][I1]-((fq(A[2],4*Rh[2],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J2[0][i2]=0;	}
		if(fmodell==3)
		{	HL2[0][i2]=HL1[0][I1]-((fq(A[2],4*Rh[2],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J2[0][i2]=(dx*fq(A[2],4*Rh[2],Q0)*Q0*Q0)/(A[2]*A[2]*4*Rh[2]*2*g*g);	}
		x=x+dx;					}

	for (i3=0;i3<=I3;i3++)
	{	QL3[0][i3]=Q0;
		if(fmodell==1)
		{	HL3[0][i3]=HL2[0][I2]-((f*Q0*Q0*i3*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J3[0][i3]=0;	}
		if(fmodell==2)
		{	HL3[0][i3]=HL2[0][I2]-((fq(A[3],4*Rh[3],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J3[0][i3]=0;	}
		if(fmodell==3)
		{	HL3[0][i3]=HL2[0][I2]-((fq(A[3],4*Rh[3],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J3[0][i3]=(dx*fq(A[3],4*Rh[3],Q0)*Q0*Q0)/(A[3]*A[3]*4*Rh[3]*2*g*g);	}
		x=x+dx;					}

	for (i4=0;i4<=I4;i4++)
	{	QL4[0][i4]=Q0;
		if(fmodell==1)
		{	HL4[0][i4]=HL3[0][I3]-((f*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J4[0][i4]=0;	}
		if(fmodell==2)
		{	HL4[0][i4]=HL3[0][I3]-((fq(A[4],4*Rh[4],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J4[0][i4]=0;	}
		if(fmodell==3)
		{	HL4[0][i4]=HL3[0][I3]-((fq(A[4],4*Rh[4],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J4[0][i4]=(dx*fq(A[4],4*Rh[4],Q0)*Q0*Q0)/(A[4]*A[4]*4*Rh[4]*2*g*g);	}
		x=x+dx;					}

	for (i5=0;i5<=I5;i5++)
	{	QL5[0][i5]=Q0;
		if(fmodell==1)
		{	HL5[0][i5]=HL4[0][I4]-((f*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J5[0][i5]=0;	}
		if(fmodell==2)
		{	HL5[0][i5]=HL4[0][I4]-((fq(A[5],4*Rh[5],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J5[0][i5]=0;	}
		if(fmodell==3)
		{	HL5[0][i5]=HL4[0][I4]-((fq(A[5],4*Rh[5],Q0)*Q0*Q0*i2*dx)/(A[2]*A[2]*4*Rh[2]*2*g));
			J5[0][i5]=(dx*fq(A[5],4*Rh[5],Q0)*Q0*Q0)/(A[5]*A[5]*4*Rh[5]*2*g*g);	}
		x=x+dx;					}

	for (i8=I8;i8>=0;i8--)
	{	QL8[0][i8]=Q0;
		if(fmodell==1)
		{	HL8[0][i8]=Hu+((f*Q0*Q0*(I8-i8)*dx)/(A[8]*A[8]*4*Rh[8]*2*g));
			J8[0][i8]=0;	}
		if(fmodell==2)
		{	HL8[0][i8]=Hu+((fq(A[8],4*Rh[8],Q0)*Q0*Q0*(I8-i8)*dx)/(A[8]*A[8]*4*Rh[8]*2*g));
			J8[0][i8]=0;	}
		if(fmodell==3)
		{	HL8[0][i8]=Hu+((fq(A[8],4*Rh[8],Q0)*Q0*Q0*(I8-i8)*dx)/(A[8]*A[8]*4*Rh[8]*2*g));
			J8[0][i8]=(dx*fq(A[8],4*Rh[8],Q0)*Q0*Q0)/(A[8]*A[8]*4*Rh[8]*2*g*g);	}
		x=x+dx;					}

	for (i7=I7;i7>=0;i7--)
	{	QL7[0][i7]=Q0;
		if(fmodell==1)
		{	HL7[0][i7]=HL8[0][0]+((f*Q0*Q0*(I7-i7)*dx)/(A[7]*A[7]*4*Rh[7]*2*g));
			J7[0][i7]=0;	}
		if(fmodell==2)
		{	HL7[0][i7]=HL8[0][0]+((fq(A[7],4*Rh[7],Q0)*Q0*Q0*(I7-i7)*dx)/(A[7]*A[7]*4*Rh[7]*2*g));
			J7[0][i7]=0;	}
		if(fmodell==3)
		{	HL7[0][i7]=HL8[0][0]+((fq(A[7],4*Rh[7],Q0)*Q0*Q0*(I7-i7)*dx)/(A[7]*A[7]*4*Rh[7]*2*g));
			J7[0][i7]=(dx*fq(A[7],4*Rh[7],Q0)*Q0*Q0)/(A[7]*A[7]*4*Rh[7]*2*g*g);	}
		x=x+dx;					}

	for (i6=I6;i6>=0;i6--)
	{	QL6[0][i6]=Q0;
		if(fmodell==1)
		{	HL6[0][i6]=HL7[0][0]+((f*Q0*Q0*(I6-i6)*dx)/(A[6]*A[6]*4*Rh[6]*2*g));
			J6[0][i6]=0;	}
		if(fmodell==2)
		{	HL6[0][i6]=HL7[0][0]+((fq(A[7],4*Rh[7],Q0)*Q0*Q0*(I6-i6)*dx)/(A[6]*A[6]*4*Rh[6]*2*g));
			J6[0][i6]=0;	}
		if(fmodell==3)
		{	HL6[0][i6]=HL7[0][0]+((fq(A[7],4*Rh[7],Q0)*Q0*Q0*(I6-i6)*dx)/(A[6]*A[6]*4*Rh[6]*2*g));
			J6[0][i6]=(dx*fq(A[6],4*Rh[6],Q0)*Q0*Q0)/(A[6]*A[6]*4*Rh[6]*2*g*g);	}
		x=x+dx;					}

if(Bekk==1)
{		for (i9=0;i9<=I9;i9++)
		{	QL9[0][i9]=Q0bekk;
			if(fmodell==1)
			{	HL9[0][i9]=H0-((f*Q0bekk*Q0bekk*i9*dx)/(A[9]*A[9]*4*Rh[9]*2*g));
				J9[0][i9]=0;	}
			if(fmodell==2)
			{	HL9[0][i9]=H0-((fq(A[9],4*Rh[9],Q0bekk)*Q0bekk*Q0bekk*i9*dx)/(A[9]*A[9]*4*Rh[9]*2*g));
				J9[0][i9]=0;	}
			if(fmodell==3)
			{	HL9[0][i9]=H0-((fq(A[9],4*Rh[9],Q0bekk)*Q0bekk*Q0bekk*i9*dx)/(A[9]*A[9]*4*Rh[9]*2*g));
				J9[0][i9]=(dx*fq(A[9],4*Rh[9],Q0bekk)*Q0bekk*Q0bekk)/(A[9]*A[9]*4*Rh[9]*2*g*g);	}
			x=x+dx;					}

		for (i10=0;i10<=I10;i10++)
		{	QL10[0][i10]=Q0bekk;
			if(fmodell==1)
			{	HL10[0][i10]=HL9[0][I9]-((f*Q0bekk*Q0bekk*i10*dx)/(A[10]*A[10]*4*Rh[10]*2*g));
				J10[0][i10]=0;	}
			if(fmodell==2)
			{	HL10[0][i10]=HL9[0][I9]-((fq(A[10],4*Rh[10],Q0bekk)*Q0bekk*Q0bekk*i10*dx)/(A[10]*A[10]*4*Rh[10]*2*g));
				J10[0][i10]=0;	}
			if(fmodell==3)
			{	HL10[0][i10]=HL9[0][I9]-((fq(A[10],4*Rh[10],Q0bekk)*Q0bekk*Q0bekk*i10*dx)/(A[10]*A[10]*4*Rh[10]*2*g));
				J10[0][i10]=(dx*fq(A[10],4*Rh[10],Q0bekk)*Q0bekk*Q0bekk)/(A[10]*A[10]*4*Rh[10]*2*g*g);	}

		x=x+dx;					}
}
else
{		for (i9=0;i9<=I9;i9++)
		{	QL9[0][i9]=0;
			HL9[0][i9]=HL1[0][I1];
			J9[0][i9]=0;
			x=x+dx;					}

		for (i10=0;i10<=I10;i10++)
		{	QL10[0][i10]=0;
			HL10[0][i10]=HL1[0][I1];
			J10[0][i10]=0;
			x=x+dx;					}
}

	for (is1=0;is1<=Is1;is1++)
	{	QLs1[0][is1]=0;
		if(S1==1)
		{	HLs1[0][is1]=HL2[0][I2];}
		else if(S2==1)
		{	HLs1[0][is1]=HL3[0][I3];}
		Js1[0][is1]=0;
		x=x+dx;			}

	for (is3=0;is3<=Is3;is3++)
	{	QLs3[0][is3]=0;
		HLs3[0][is3]=HL1[0][I1];
		Js3[0][is3]=0;
		x=x+dx;			}

	for (is2=0;is2<=Is2;is2++)
	{	QLs2[0][is2]=0;
		HLs2[0][is2]=HL7[0][I7];
		Js2[0][is2]=0;
		x=x+dx;			}

	for (i11=0;i11<=I11;i11++)
	{	QL11[0][i11]=0;
		HL11[0][i11]=HL3[0][I3];
		J11[0][i11]=0;
		x=x+dx;			}

	for (i12=0;i12<=I12;i12++)
	{	QL12[0][i12]=0;
		HL12[0][i12]=HL3[0][I3];
		J12[0][i12]=0;
		x=x+dx;			}

float Hn=HL5[0][I5]-HL6[0][0];	//Forenklet beregning av Hn for at steady state skal inntreffe hurtigere
								//Gjelder om det beregnes avslag, men blir litt for hy hvis det startes med Q0=0

if(S1==1)
{	Z1=HL2[0][I2];	}
else if(S2==1)
{	Z1=HL3[0][I3];	}
else
{	Z1=0;	}

if(S4==1)
{	Z2=HL7[0][I7];	}
else
{	Z2=0;	}

if(S3==1)
{	Z3=HL1[0][I1];	}
else
{	Z3=0;	}

//printf("%f\t%f\n", HL3[0][0],H0);

	/*Slutt p initialisering*/

/***************************Hovedlkke***********************/
	int j=0;
		t=0;

	float R1=0,R2=0,R3=0,Rs1=0,R4=0,R5=0,R9=0,R10=0,R6=0,R7=0,R8=0,Rs2=0,Rs3=0,R11=0,R12=0;
	float Bs1=a/(g*As[1]);										//Definisjon av konstanter
	float Bs2=a/(g*As[2]);
	float Bs3=a/(g*As[3]);
	float B1=a/(g*A[1]);
	float B2=a/(g*A[2]);
	float B3=a/(g*A[3]);
	float B4=a/(g*A[4]);
	float B5=a/(g*A[5]);
	float B6=a/(g*A[6]);
	float B7=a/(g*A[7]);
	float B8=a/(g*A[8]);
	float B9=a/(g*A[9]);
	float B10=a/(g*A[10]);
	float B11=a/(g*A[11]);
	float B12=a/(g*A[12]);

	float Cm1,Cm2,Cms1,Cp1,Cp2,Cps1,Cp3,Cm3,Cm4,Cp4,Cm5,Cp5,Cp9,Cm9,Cm10,Cp10,Cp6,Cm6,Cp7,Cm7,Cp8,Cm8,Cms3,Cps3,Cm11,Cm12,Cp11,Cp12;
	float Bm1,Bm2,Bms1,Bp1,Bp2,Bps1,Bp3,Bm3,Bm4,Bp4,Bm5,Bp5,Bp9,Bm9,Bm10,Bp10,Bp6,Bm6,Bp7,Bm7,Bp8,Bm8,Bms3,Bps3,Bm11,Bp11,Bm12,Bp12;
	float Sc12,Sb12,Cn12,Bn12,QN,C1,C2,Sc9s1,Sb9s1,Cn9s1,Bn9s1,Sc78,Sb78,Cn78,Bn78;
	float Sc23,Sb23,Cn23,Bn23,Sc34,Sb34,Cn34,Bn34,Cn67,Bn67,Sc67,Sb67;
	float Cms2,Cps2,Bms2,Bps2;

float djdt,K=0.4128,Y=0.271,Js;

for (j=0;j<=T;j++)
{
printf("%f %%\n",((float)j/T)*100);
			//////////// Rr 1 ////////////////

			for (i1=0;i1<I1;i1++)
			{
				if (i1==0)
				{	if(fmodell==1)
					{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);}
					else if(fmodell==2)
					{	R1=(fq(A[1],4*Rh[1],QL1[0][0])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);}
					else if(fmodell==3)
					{	R1=0;}

					HL1ny[0][0]=H0;
					Cm1=HL1[0][1]-(B1*QL1[0][1])+(g*J1[0][0]);
					Bm1=B1+(R1*fabs(QL1[0][1]));
					QL1ny[0][0]=(H0-Cm1)/Bm1;

					if(fmodell==3)
					{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][0])*QL1[0][0]*QL1[0][0])/(A[1]*A[1]*4*Rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][0]-QL1[0][0]))-J1[0][0]+Js);
						J1ny[0][0]=J1[0][0]+(djdt*dt);
												}
					else
					{	J1ny[0][0]=0;	}
				}
				else
				{	if(fmodell==1)
					{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);	}
					else if(fmodell==2)
					{	R1=(fq(A[1],4*Rh[1],QL1[0][i1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);}
					else if(fmodell==3)
					{	R1=0;}

					Cp1=HL1[0][i1-1]+(B1*QL1[0][i1-1])-(g*J1[0][i1]);
					Bp1=B1+(R1*fabs(QL1[0][i1-1]));
					Cm1=HL1[0][i1+1]-(B1*QL1[0][i1+1])+(g*J1[0][i1]);
					Bm1=B1+(R1*fabs(QL1[0][i1+1]));
					HL1ny[0][i1]=( ((Cp1*Bm1)+(Cm1*Bp1)) / (Bp1+Bm1));
					QL1ny[0][i1]=( (Cp1-Cm1)/(Bp1+Bm1) );

					if(fmodell==3)
					{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][i1])*QL1[0][i1]*QL1[0][i1])/(A[1]*A[1]*4*Rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][i1]-QL1[0][i1]))-J1[0][i1]+Js);
						J1ny[0][i1]=J1[0][i1]+(djdt*dt);
															}
					else
					{	J1ny[0][i1]=0;	}
				}
			}
			/////////// Slutt rr 1 ///////////

	//------------  Node 2 uten sving, uten bekk --------------//
			if(S3==0 && Bekk==0 && FLsjakt==0)
			{	if(fmodell==1)
				{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);	}
				else if(fmodell==2)
				{	R1=(fq(A[1],4*Rh[1],QL1[0][I1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(fq(A[2],4*Rh[2],QL2[0][0])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);}
				else if(fmodell==3)
				{	R1=0;
					R2=0;}

				Cp1=HL1[0][I1-1]+(B1*QL1[0][I1-1])-(g*J1[0][I1]);
				Bp1=B1+(R1*fabs(QL1[0][I1-1]));
				Cm2=HL2[0][1]-(B2*QL2[0][1])+(g*J2[0][0]);
				Bm2=B2+(R2*fabs(QL2[0][1]));
				float ScN2=(Cp1/Bp1)+(Cm2/Bm2);
				float SbN2=(1/Bp1)+(1/Bm2);
				float CnN2=ScN2/SbN2;
				float BnN2=1/SbN2;
				float Qn=0;
				float Hj=CnN2+(BnN2*Qn);
				HL1ny[0][I1]=Hj;
				HL2ny[0][0]=Hj;
				QL1ny[0][I1]=(Cp1-Hj)/Bp1;
				QL2ny[0][0]=(Hj-Cm2)/Bm2;

				if(fmodell==3)
				{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][I1])*QL1[0][I1]*QL1[0][I1])/(A[1]*A[1]*4*Rh[1]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][I1]-QL1[0][I1]))-J1[0][I1]+Js);
					J1ny[0][I1]=J1[0][I1]+(djdt*dt);
					float Js2=(dx*fq(A[2],4*Rh[2],QL2[0][0])*QL2[0][0]*QL2[0][0])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					float djdt2=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][0]-QL2[0][0]))-J2[0][0]+Js2);
					J2ny[0][0]=J2[0][0]+(djdt2*dt);
															}
				else
				{	J1ny[0][I1]=0;
					J2ny[0][0]=0;}
			}
	//---------------- Slutt node 2 uten sving-----------------//

	//------------  Node 2 med sving, uten bekk --------------//
			if(S3==1 && Bekk==0 && FLsjakt==0)
			{	if(fmodell==1)
				{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					Rs3=(f*dx)/(2*g*4*rh[3]*As[3]*As[3]);	}
				else if(fmodell==2)
				{	R1=(fq(A[1],4*Rh[1],QL1[0][I1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(fq(A[2],4*Rh[2],QL2[0][0])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					Rs3=(fq(As[3],4*rh[3],QLs3[0][0])*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
				else if(fmodell==3)
				{	R1=0;
					R2=0;
					Rs3=0;}

				Cp1=HL1[0][I1-1]+(B1*QL1[0][I1-1])-(g*J1[0][I1]);
				Bp1=B1+(R1*fabs(QL1[0][I1-1]));
				Cm2=HL2[0][1]-(B2*QL2[0][1])+(g*J2[0][0]);
				Bm2=B2+(R2*fabs(QL2[0][1]));
				Cms3=HLs3[0][1]-(Bs3*QLs3[0][1])+(g*Js3[0][0]);
				Bms3=Bs3+(Rs3*fabs(QLs3[0][1]));
				float ScN2=(Cp1/Bp1)+(Cm2/Bm2)+(Cms3/Bms3);
				float SbN2=(1/Bp1)+(1/Bm2)+(1/Bms3);
				float CnN2=ScN2/SbN2;
				float BnN2=1/SbN2;
				float Qn=0;
				float Hj=CnN2+(BnN2*Qn);
				HLs3ny[0][0]=Hj;
				HL1ny[0][I1]=Hj;
				HL2ny[0][0]=Hj;
				QLs3ny[0][0]=(Hj-Cms3)/Bms3;
				QL1ny[0][I1]=(Cp1-Hj)/Bp1;
				QL2ny[0][0]=(Hj-Cm2)/Bm2;

				if(fmodell==3)
				{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][I1])*QL1[0][I1]*QL1[0][I1])/(A[1]*A[1]*4*Rh[1]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][I1]-QL1[0][I1]))-J1[0][I1]+Js);
					J1ny[0][I1]=J1[0][I1]+(djdt*dt);
					float Js2=(dx*fq(A[2],4*Rh[2],QL2[0][0])*QL2[0][0]*QL2[0][0])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					float djdt2=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][0]-QL2[0][0]))-J2[0][0]+Js2);
					J2ny[0][0]=J2[0][0]+(djdt2*dt);
					float Jss3=(dx*fq(As[3],4*rh[3],QLs3[0][0])*QLs3[0][0]*QLs3[0][0])/(As[3]*As[3]*4*rh[3]*2*g*g);
					float djdts3=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][0]-QLs3[0][0]))-Js3[0][0]+Jss3);
					Js3ny[0][0]=Js3[0][0]+(djdts3*dt);
															}
				else
				{	J1ny[0][I1]=0;
					J2ny[0][0]=0;
					Js3ny[0][0]=0;}

				/////////////////Start rr s1/////////////////////////
					for (is3=1;is3<Is3;is3++)
					{	if(fmodell==1)
						{	Rs3=(f*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
						else if(fmodell==2)
						{	Rs3=(fq(As[3],4*rh[3],QLs3[0][is3])*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
						else if(fmodell==3)
						{	Rs3=0;}

						Cps3=HLs3[0][is3-1]+(Bs3*QLs3[0][is3-1])-(g*Js3[0][is3]);
						Bps3=Bs3+(Rs3*fabs(QLs3[0][is3-1]));
						Cms3=HLs3[0][is3+1]-(Bs3*QLs3[0][is3+1])+(g*Js3[0][is3]);
						Bms3=Bs3+(Rs3*fabs(QLs3[0][is3+1]));
						HLs3ny[0][is3]=( ((Cps3*Bms3)+(Cms3*Bps3)) / (Bps3+Bms3));
						QLs3ny[0][is3]=( (Cps3-Cms3)/(Bps3+Bms3) );

						if(fmodell==3)
						{	Js=(dx*fq(As[3],4*rh[3],QLs3[0][is3])*QLs3[0][is3]*QLs3[0][is3])/(As[3]*As[3]*4*rh[3]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][is3]-QLs3[0][is3]))-Js3[0][is3]+Js);
						Js3ny[0][is3]=Js3[0][is3]+(djdt*dt);
																				}
						else
						{	Js3ny[0][is3]=0;	}
					}

					Cps3=HLs3[0][Is3-1]+(Bs3*QLs3[0][Is3-1])-(g*Js3[0][Is3]);
					Bps3=Bs3+(Rs3*fabs(QLs3[0][Is3-1]));
					QLs3ny[0][Is3]=(Cps3-HLs3[0][Is3])/Bps3;
					HLs3ny[0][Is3]=HLs3[0][Is3]+((QLs3ny[0][Is3]/Arealsjakt(Z3))*dt);
					Z3=Z3+((QLs3ny[0][Is3]/Arealsjakt(Z3))*dt);

					if(fmodell==3)
					{	Js=(dx*fq(As[3],4*rh[3],QLs3[0][Is3])*QLs3[0][Is3]*QLs3[0][Is3])/(As[3]*As[3]*4*rh[3]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][Is3]-QLs3[0][Is3]))-Js3[0][Is3]+Js);
						Js3ny[0][Is3]=Js3[0][Is3]+(djdt*dt);
															}
					else
					{	Js3ny[0][Is3]=0;	}
				////////////////Slutt rr s1//////////////////////////
			}
	//---------------- Slutt node 2 m/sving u/Bekk--------------//

	//--------------- Node 2 m/ vannfring i Bekk --------------//
			if(Bekk==1 && FLsjakt==0)
			{	if(fmodell==1)
				{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R10=(f*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
					R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);		}
				else if(fmodell==2)
				{	R1=(fq(A[1],4*Rh[1],QL1[0][I1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(fq(A[2],4*Rh[2],QL2[0][0])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R10=(fq(A[10],4*Rh[10],QL10[0][0])*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
					R9=(fq(A[9],4*Rh[9],QL9[0][I9])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);}
				else if(fmodell==3)
				{	R1=0;
					R2=0;
					R10=0;
					R9=0;}

					//////////// Start Rr 10 /////////////
					HL10ny[0][0]=H0;
					Cm10=HL10[0][1]-(B10*QL10[0][1])+(g*J10[0][0]);
					Bm10=B10+(R10*fabs(QL10[0][1]));
					QL10ny[0][0]=(H0-Cm10)/Bm10;

					if(fmodell==3)
					{	Js=(dx*fq(A[10],4*Rh[10],QL10[0][0])*QL10[0][0]*QL10[0][0])/(A[10]*A[10]*4*Rh[10]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[10]))*(QL10ny[0][0]-QL10[0][0]))-J10[0][0]+Js);
						J10ny[0][0]=J10[0][0]+(djdt*dt);
															}
					else
					{	J10ny[0][0]=0;	}

					for (i10=1;i10<I10;i10++)
					{	if(fmodell==1)
						{	R10=(f*dx)/(2*g*4*Rh[10]*A[10]*A[10]);	}
						else if(fmodell==2)
						{	R10=(fq(A[10],4*Rh[10],QL10[0][i10])*dx)/(2*g*4*Rh[10]*A[10]*A[10]);}
						else if(fmodell==3)
						{	R10=0;}

						Cp10=HL10[0][i10-1]+(B10*QL10[0][i10-1])-(g*J10[0][i10]);
						Bp10=B10+(R10*fabs(QL10[0][i10-1]));
						Cm10=HL10[0][i10+1]-(B10*QL10[0][i10+1])+(g*J10[0][i10]);
						Bm10=B10+(R10*fabs(QL10[0][i10+1]));
						HL10ny[0][i10]=( ((Cp10*Bm10)+(Cm10*Bp10)) / (Bp10+Bm10));
						QL10ny[0][i10]=( (Cp10-Cm10)/(Bp10+Bm10) );
						if(fmodell==3)
						{	Js=(dx*fq(A[10],4*Rh[10],QL10[0][i10])*QL10[0][i10]*QL10[0][i10])/(A[10]*A[10]*4*Rh[10]*2*g*g);
							djdt=(1/Y)*	(((K/(g*A[10]))*(QL10ny[0][i10]-QL10[0][i10]))-J10[0][i10]+Js);
							J10ny[0][i10]=J10[0][i10]+(djdt*dt);
																}
						else
						{	J10ny[0][i10]=0;	}
					}
					//////////// Slutt Rr 10 /////////////
					//--------------  Node 3s uten sving  --------------//
							if(S3==0)
							{	if(fmodell==1)
								{	R10=(f*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
									R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);		}
								else if(fmodell==2)
								{	R10=(fq(A[10],4*Rh[10],QL10[0][I10])*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
									R9=(fq(A[9],4*Rh[9],QL9[0][0])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);}
								else if(fmodell==3)
								{	R10=0;
									R9=0;}


								Cp10=HL10[0][I10-1]+(B10*QL10[0][I10-1])-(g*J10[0][I10]);
								Bp10=B10+(R10*fabs(QL10[0][I10-1]));
								Cm9=HL9[0][1]-(B9*QL9[0][1])+(g*J9[0][0]);
								Bm9=B9+(R9*fabs(QL9[0][1]));
								float ScN3s=(Cp10/Bp10)+(Cm9/Bm9);
								float SbN3s=(1/Bp10)+(1/Bm9);
								float CnN3s=ScN3s/SbN3s;
								float BnN3s=1/SbN3s;
								float Qn=0;
								float Hj=CnN3s+(BnN3s*Qn);
								HL10ny[0][I10]=Hj;
								HL9ny[0][0]=Hj;
								QL10ny[0][I10]=(Cp10-Hj)/Bp10;
								QL9ny[0][0]=(Hj-Cm9)/Bm9;
								if(fmodell==3)
								{	Js=(dx*fq(A[10],4*Rh[10],QL10[0][I10])*QL10[0][I10]*QL10[0][I10])/(A[10]*A[10]*4*Rh[10]*2*g*g);
									djdt=(1/Y)*	(((K/(g*A[10]))*(QL10ny[0][I10]-QL10[0][I10]))-J10[0][I10]+Js);
									J10ny[0][I10]=J10[0][I10]+(djdt*dt);
									float Js9=(dx*fq(A[9],4*Rh[9],QL9[0][0])*QL9[0][0]*QL9[0][0])/(A[9]*A[9]*4*Rh[9]*2*g*g);
									float djdt9=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][0]-QL9[0][0]))-J9[0][0]+Js9);
									J9ny[0][0]=J9[0][0]+(djdt9*dt);
																		}
								else
								{	J10ny[0][I10]=0;
									J9ny[0][0]=0;}
							}
					//-------------Slutt node 3s uten sving--------------//
					//--------------  Node 3s med sving  --------------//
							if(S3==1)
							{	if(fmodell==1)
								{	R10=(f*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
									R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
									Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
								else if(fmodell==2)
								{	R10=(fq(A[10],4*Rh[10],QL10[0][I10])*dx)/(2*g*4*Rh[10]*A[10]*A[10]);
									R9=(fq(A[9],4*Rh[9],QL9[0][0])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
									Rs1=(fq(As[1],4*rh[1],QLs1[0][0])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
								else if(fmodell==3)
								{	R10=0;
									R9=0;
									Rs1=0;}

								Cp10=HL10[0][I10-1]+(B10*QL10[0][I10-1])-(g*J10[0][I10]);
								Bp10=B10+(R10*fabs(QL10[0][I10-1]));
								Cm9=HL9[0][1]-(B9*QL9[0][1])+(g*J9[0][0]);
								Bm9=B9+(R9*fabs(QL9[0][1]));
								Cms1=HLs1[0][1]-(Bs1*QLs1[0][1])+(g*Js1[0][0]);
								Bms1=Bs1+(Rs1*fabs(QLs1[0][1]));
								float ScN3s=(Cp10/Bp10)+(Cm9/Bm9)+(Cms1/Bms1);
								float SbN3s=(1/Bp10)+(1/Bm9)+(1/Bms1);
								float CnN3s=ScN3s/SbN3s;
								float BnN3s=1/SbN3s;
								float Qn=0;
								float Hj=CnN3s+(BnN3s*Qn);
								HL10ny[0][I10]=Hj;
								HL9ny[0][0]=Hj;
								HLs1ny[0][0]=Hj;
								QL10ny[0][I10]=(Cp10-Hj)/Bp10;
								QL9ny[0][0]=(Hj-Cm9)/Bm9;
								QLs1ny[0][0]=(Hj-Cms1)/Bms1;
								if(fmodell==3)
								{	Js=(dx*fq(A[10],4*Rh[10],QL10[0][I10])*QL10[0][I10]*QL10[0][I10])/(A[10]*A[10]*4*Rh[10]*2*g*g);
									djdt=(1/Y)*	(((K/(g*A[10]))*(QL10ny[0][I10]-QL10[0][I10]))-J10[0][I10]+Js);
									J10ny[0][I10]=J10[0][I10]+(djdt*dt);
									float Js9=(dx*fq(A[9],4*Rh[9],QL9[0][0])*QL9[0][0]*QL9[0][0])/(A[9]*A[9]*4*Rh[9]*2*g*g);
									float djdt9=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][0]-QL9[0][0]))-J9[0][0]+Js9);
									J9ny[0][0]=J9[0][0]+(djdt9*dt);
									float Jss1=(dx*fq(As[1],4*rh[1],QLs1[0][0])*QLs1[0][0]*QLs1[0][0])/(As[1]*As[1]*4*rh[1]*2*g*g);
									float djdts1=(1/Y)*(((K/(g*As[1]))*(QLs1ny[0][0]-QLs1[0][0]))-Js1[0][0]+Jss1);
									Js1ny[0][0]=Js1[0][0]+(djdts1*dt);
																		}
								else
								{	J10ny[0][I10]=0;
									J9ny[0][0]=0;
									Js1ny[0][0]=0;}

							/////////////////Start rr s1/////////////////////////
								for (is1=1;is1<Is1;is1++)
								{	if(fmodell==1)
									{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
									else if(fmodell==2)
									{	Rs1=(fq(As[1],4*rh[1],QLs1[0][is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
									else if(fmodell==3)
									{	Rs1=0;}

									Cps1=HLs1[0][is1-1]+(Bs1*QLs1[0][is1-1])-(g*Js1[0][is1]);
									Bps1=Bs1+(Rs1*fabs(QLs1[0][is1-1]));
									Cms1=HLs1[0][is1+1]-(Bs1*QLs1[0][is1+1])+(g*Js1[0][is1]);
									Bms1=Bs1+(Rs1*fabs(QLs1[0][is1+1]));
									HLs1ny[0][is1]=( ((Cps1*Bms1)+(Cms1*Bps1)) / (Bps1+Bms1));
									QLs1ny[0][is1]=( (Cps1-Cms1)/(Bps1+Bms1) );
									if(fmodell==3)
									{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][is1])*QLs1[0][is1]*QLs1[0][is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
										djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][is1]-QLs1[0][is1]))-Js1[0][is1]+Js);
										Js1ny[0][is1]=Js1[0][is1]+(djdt*dt);
																			}
									else
									{	Js1ny[0][is1]=0;	}
								}

								if(fmodell==1)
								{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
								else if(fmodell==2)
								{	Rs1=(fq(As[1],4*rh[1],QLs1[0][is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
								else if(fmodell==3)
								{	Rs1=0;}

								Cps1=HLs1[0][Is1-1]+(Bs1*QLs1[0][Is1-1])-(g*Js1[0][Is1]);
								Bps1=Bs1+(Rs1*fabs(QLs1[0][Is1-1]));
								QLs1ny[0][Is1]=(Cps1-HLs1[0][Is1])/Bps1;
								HLs1ny[0][Is1]=HLs1[0][Is1]+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);
								Z1=Z1+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);
								if(fmodell==3)
								{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][Is1])*QLs1[0][Is1]*QLs1[0][Is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
									djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][Is1]-QLs1[0][Is1]))-Js1[0][Is1]+Js);
									Js1ny[0][Is1]=Js1[0][Is1]+(djdt*dt);
																		}
								else
								{	Js1ny[0][Is1]=0;	}

							////////////////Slutt rr s1//////////////////////////
							}
					//-------------Slutt node 3s med sving--------------//
					//////////// Start Rr 9 /////////////

					for (i9=1;i9<I9;i9++)
					{	if(fmodell==1)
						{	R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);	}
						else if(fmodell==2)
						{	R9=(fq(A[9],4*Rh[9],QL9[0][i9])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);}
						else if(fmodell==3)
						{	R9=0;}

						Cp9=HL9[0][i9-1]+(B9*QL9[0][i9-1])-(g*J9[0][i9]);
						Bp9=B9+(R9*fabs(QL9[0][i9-1]));
						Cm9=HL9[0][i9+1]-(B9*QL9[0][i9+1])+(g*J9[0][i9]);
						Bm9=B9+(R9*fabs(QL9[0][i9+1]));
						HL9ny[0][i9]=( ((Cp9*Bm9)+(Cm9*Bp9)) / (Bp9+Bm9));
						QL9ny[0][i9]=( (Cp9-Cm9)/(Bp9+Bm9) );
						if(fmodell==3)
						{	Js=(dx*fq(A[9],4*Rh[9],QL9[0][i9])*QL9[0][i9]*QL9[0][i9])/(A[9]*A[9]*4*Rh[9]*2*g*g);
							djdt=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][i9]-QL9[0][i9]))-J9[0][i9]+Js);
							J9ny[0][i9]=J9[0][i9]+(djdt*dt);
																			}
						else
						{	J9ny[0][i9]=0;	}

					}
					//////////// Slutt Rr 9 /////////////
				if(fmodell==1)
				{	R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
					R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);}
				else if(fmodell==2)
				{	R9=(fq(A[9],4*Rh[9],QL9[0][I9])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
					R1=(fq(A[1],4*Rh[1],QL1[0][I1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(fq(A[2],4*Rh[2],QL2[0][0])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);}
				else if(fmodell==3)
				{	R9=0;
					R1=0;
					R2=0;}

				Cp1=HL1[0][I1-1]+(B1*QL1[0][I1-1])-(g*J1[0][I1]);
				Bp1=B1+(R1*fabs(QL1[0][I1-1]));
				Cp9=HL9[0][I9-1]+(B9*QL9[0][I9-1])-(g*J9[0][I9]);
				Bp9=B9+(R9*fabs(QL9[0][I9-1]));
				Cm2=HL2[0][1]-(B2*QL2[0][1])+(g*J2[0][0]);
				Bm2=B2+(R2*fabs(QL2[0][1]));
				float ScN2=(Cp1/Bp1)+(Cp9/Bp9)+(Cm2/Bm2);
				float SbN2=(1/Bp1)+(1/Bp9)+(1/Bm2);
				float CnN2=ScN2/SbN2;
				float BnN2=1/SbN2;
				float Qn=0;
				float Hj=CnN2+(BnN2*Qn);
				HL1ny[0][I1]=Hj;
				HL9ny[0][I9]=Hj;
				HL2ny[0][0]=Hj;
				QL1ny[0][I1]=(Cp1-Hj)/Bp1;
				QL9ny[0][I9]=(Cp9-Hj)/Bp9;
				QL2ny[0][0]=(Hj-Cm2)/Bm2;
				if(fmodell==3)
				{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][I1])*QL1[0][I1]*QL1[0][I1])/(A[1]*A[1]*4*Rh[1]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][I1]-QL1[0][I1]))-J1[0][I1]+Js);
					J1ny[0][I1]=J1[0][I1]+(djdt*dt);
					float Js9=(dx*fq(A[9],4*Rh[9],QL9[0][I9])*QL9[0][I9]*QL9[0][I9])/(A[9]*A[9]*4*Rh[9]*2*g*g);
					float djdt9=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][I9]-QL9[0][I9]))-J9[0][I9]+Js9);
					J9ny[0][I9]=J9[0][I9]+(djdt9*dt);
					float Js2=(dx*fq(A[2],4*Rh[2],QL2[0][0])*QL2[0][0]*QL2[0][0])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					float djdt2=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][0]-QL2[0][0]))-J2[0][0]+Js2);
					J2ny[0][0]=J2[0][0]+(djdt2*dt);
															}
				else
				{	J1ny[0][I1]=0;
					J9ny[0][I9]=0;
					J2ny[0][0]=0;}

			}
	//------------- Slutt node 2 m/vannfring i Bekk------------//

	//------------  Node 2 med sving, med FLsjakt --------------//
			if(S3==1 && FLsjakt==1 && Bekk==0)
			{	if(fmodell==1)
				{	R1=(f*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);	}
				else if(fmodell==2)
				{	R1=(fq(A[1],4*Rh[1],QL1[0][I1])*dx)/(2*g*4*Rh[1]*A[1]*A[1]);
					R2=(fq(A[2],4*Rh[2],QL2[0][0])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R9=(fq(A[9],4*Rh[9],QL9[0][0])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);		}
				else if(fmodell==3)
				{	R1=0;
					R2=0;
					R9=0;		}

				Cp1=HL1[0][I1-1]+(B1*QL1[0][I1-1])-(g*J1[0][I1]);
				Bp1=B1+(R1*fabs(QL1[0][I1-1]));
				Cm2=HL2[0][1]-(B2*QL2[0][1])+(g*J2[0][0]);
				Bm2=B2+(R2*fabs(QL2[0][1]));
				Cm9=HL9[0][1]-(B9*QL9[0][1])+(g*J9[0][0]);
				Bm9=B9+(R9*fabs(QL9[0][1]));
				float ScN2=(Cp1/Bp1)+(Cm2/Bm2)+(Cm9/Bm9);
				float SbN2=(1/Bp1)+(1/Bm2)+(1/Bm9);
				float CnN2=ScN2/SbN2;
				float BnN2=1/SbN2;
				float Qn=0;
				float Hj=CnN2+(BnN2*Qn);
				HL9ny[0][0]=Hj;
				HL1ny[0][I1]=Hj;
				HL2ny[0][0]=Hj;
				QL9ny[0][0]=(Hj-Cm9)/Bm9;
				QL1ny[0][I1]=(Cp1-Hj)/Bp1;
				QL2ny[0][0]=(Hj-Cm2)/Bm2;

				if(fmodell==3)
				{	Js=(dx*fq(A[1],4*Rh[1],QL1[0][I1])*QL1[0][I1]*QL1[0][I1])/(A[1]*A[1]*4*Rh[1]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[1]))*(QL1ny[0][I1]-QL1[0][I1]))-J1[0][I1]+Js);
					J1ny[0][I1]=J1[0][I1]+(djdt*dt);
					float Js9=(dx*fq(A[9],4*Rh[9],QL9[0][0])*QL9[0][0]*QL9[0][0])/(A[9]*A[9]*4*Rh[9]*2*g*g);
					float djdt9=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][0]-QL9[0][0]))-J9[0][0]+Js9);
					J9ny[0][0]=J9[0][0]+(djdt9*dt);
					float Js2=(dx*fq(A[2],4*Rh[2],QL2[0][0])*QL2[0][0]*QL2[0][0])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					float djdt2=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][0]-QL2[0][0]))-J2[0][0]+Js2);
					J2ny[0][0]=J2[0][0]+(djdt2*dt);
															}
				else
				{	J1ny[0][I1]=0;
					J9ny[0][0]=0;
					J2ny[0][0]=0;}
				/////////////////Start rr 9/////////////////////////
					for (i9=1;i9<I9;i9++)
					{	if(fmodell==1)
						{	R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);	}
						else if(fmodell==2)
						{	R9=(fq(A[9],4*Rh[9],QL9[0][i9])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);}
						else if(fmodell==3)
						{	R9=0;}

						Cp9=HL9[0][i9-1]+(B9*QL9[0][i9-1])-(g*J9[0][i9]);
						Bp9=B9+(R9*fabs(QL9[0][i9-1]));
						Cm9=HL9[0][i9+1]-(B9*QL9[0][i9+1])+(g*J9[0][i9]);
						Bm9=B9+(R9*fabs(QL9[0][i9+1]));
						HL9ny[0][i9]=( ((Cp9*Bm9)+(Cm9*Bp9)) / (Bp9+Bm9));
						QL9ny[0][i9]=( (Cp9-Cm9)/(Bp9+Bm9) );
						if(fmodell==3)
						{	Js=(dx*fq(A[9],4*Rh[9],QL9[0][i9])*QL9[0][i9]*QL9[0][i9])/(A[9]*A[9]*4*Rh[9]*2*g*g);
							djdt=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][i9]-QL9[0][i9]))-J9[0][i9]+Js);
							J9ny[0][i9]=J9[0][i9]+(djdt*dt);
															}
						else
						{	J9ny[0][i9]=0;	}
					}
				////////////////Slutt rr 9//////////////////////////
				//------------------ Node 3sjakt ------------------//
					if(H0>0)									//Fungerer ikke om if-setning fjernes, derfor
					{	if(fmodell==1)							//sprres det om if for noe som alltid er sant
						{	R9=(f*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
							Rs3=(f*dx)/(2*g*4*rh[3]*As[3]*As[3]);	}
						else if(fmodell==2)
						{	R9=(fq(A[9],4*Rh[9],QL9[0][I9])*dx)/(2*g*4*Rh[9]*A[9]*A[9]);
							Rs3=(fq(As[3],4*rh[3],QLs3[0][Is3])*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
						else if(fmodell==3)
						{	R9=0;
							Rs3=0;}

						Cp9=HL9[0][I9-1]+(B9*QL9[0][I9-1])-(g*J9[0][I9]);
						Bp9=B9+(R9*fabs(QL9[0][I9-1]));
						Cms3=HLs3[0][1]-(Bs3*QLs3[0][1])+(g*Js3[0][0]);
						Bms3=Bs3+(Rs3*fabs(QLs3[0][1]));
						float ScN3s=(Cp9/Bp9)+(Cms3/Bms3);
						float SbN3s=(1/Bp9)+(1/Bms3);
						float CnN3s=ScN3s/SbN3s;
						float BnN3s=1/SbN3s;
						float Qn=0;
						float Hj=CnN3s+(BnN3s*Qn);
						HL9ny[0][I9]=Hj;
						HLs3ny[0][0]=Hj;
						QL9ny[0][I9]=(Cp9-Hj)/Bp9;
						QLs3ny[0][0]=(Hj-Cms3)/Bms3;
						if(fmodell==3)
						{	Js=(dx*fq(A[9],4*Rh[9],QL9[0][I9])*QL9[0][I9]*QL9[0][I9])/(A[9]*A[9]*4*Rh[9]*2*g*g);
							djdt=(1/Y)*	(((K/(g*A[9]))*(QL9ny[0][I9]-QL9[0][I9]))-J9[0][I9]+Js);
							J9ny[0][I9]=J9[0][I9]+(djdt*dt);
							float Jss3=(dx*fq(As[3],4*rh[3],QLs3[0][0])*QLs3[0][0]*QLs3[0][0])/(As[3]*As[3]*4*rh[3]*2*g*g);
							float djdts3=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][0]-QLs3[0][0]))-Js3[0][0]+Jss3);
							Js3ny[0][0]=Js3[0][0]+(djdts3*dt);
																	}
						else
						{	J9ny[0][I9]=0;
							Js3ny[0][0]=0;}
					}

				//----------------- Slutt node 3sjakt---------------//
				/////////////////Start rr s1/////////////////////////
					for (is3=1;is3<Is3;is3++)
					{	if(fmodell==1)
						{	Rs3=(f*dx)/(2*g*4*rh[3]*As[3]*As[3]);	}
						else if(fmodell==2)
						{	Rs3=(fq(As[3],4*rh[3],QLs3[0][is3])*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
						else if(fmodell==3)
						{	Rs3=0;}

						Cps3=HLs3[0][is3-1]+(Bs3*QLs3[0][is3-1])-(g*Js3[0][is3]);
						Bps3=Bs3+(Rs3*fabs(QLs3[0][is3-1]));
						Cms3=HLs3[0][is3+1]-(Bs3*QLs3[0][is3+1])+(g*Js3[0][is3]);
						Bms3=Bs3+(Rs3*fabs(QLs3[0][is3+1]));
						HLs3ny[0][is3]=( ((Cps3*Bms3)+(Cms3*Bps3)) / (Bps3+Bms3));
						QLs3ny[0][is3]=( (Cps3-Cms3)/(Bps3+Bms3) );

						if(fmodell==3)
						{	Js=(dx*fq(As[3],4*rh[3],QLs3[0][is3])*QLs3[0][is3]*QLs3[0][is3])/(As[3]*As[3]*4*rh[3]*2*g*g);
							djdt=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][is3]-QLs3[0][is3]))-Js3[0][is3]+Js);
							Js3ny[0][is3]=Js3[0][is3]+(djdt*dt);
																									}
						else
						{	Js3ny[0][is3]=0;	}
					}

					if(fmodell==1)
					{	Rs3=(f*dx)/(2*g*4*rh[3]*As[3]*As[3]);	}
					else if(fmodell==2)
					{	Rs3=(fq(As[3],4*rh[3],QLs3[0][Is3])*dx)/(2*g*4*rh[3]*As[3]*As[3]);}
					else if(fmodell==3)
					{	Rs3=0;}

					Cps3=HLs3[0][Is3-1]+(Bs3*QLs3[0][Is3-1])-(g*Js3[0][Is3]);
					Bps3=Bs3+(Rs3*fabs(QLs3[0][Is3-1]));
					QLs3ny[0][Is3]=(Cps3-HLs3[0][Is3])/Bps3;
					HLs3ny[0][Is3]=HLs3[0][Is3]+((QLs3ny[0][Is3]/Arealsjakt(Z3))*dt);
					Z3=Z3+((QLs3ny[0][Is3]/Arealsjakt(Z3))*dt);

					if(fmodell==3)
					{	Js=(dx*fq(As[3],4*rh[3],QLs3[0][Is3])*QLs3[0][Is3]*QLs3[0][Is3])/(As[3]*As[3]*4*rh[3]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[3]))*(QLs3ny[0][Is3]-QLs3[0][Is3]))-Js3[0][Is3]+Js);
						Js3ny[0][Is3]=Js3[0][Is3]+(djdt*dt);
																									}
					else
					{	Js3ny[0][Is3]=0;	}
				////////////////Slutt rr s1//////////////////////////
			}
	//---------------- Slutt node 2 m/sving m/FLsjakt--------------//


			//////////// Start Rr 2 /////////////
			for (i2=1;i2<I2;i2++)
			{	if(fmodell==1)
				{	R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);	}
				else if(fmodell==2)
				{	R2=(fq(A[2],4*Rh[2],QL2[0][i2])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);}
				else if(fmodell==3)
				{	R2=0;}

				Cp2=HL2[0][i2-1]+(B2*QL2[0][i2-1])-(g*J2[0][i2]);
				Bp2=B2+(R2*fabs(QL2[0][i2-1]));
				Cm2=HL2[0][i2+1]-(B2*QL2[0][i2+1])+(g*J2[0][i2]);
				Bm2=B2+(R2*fabs(QL2[0][i2+1]));
				HL2ny[0][i2]=( ((Cp2*Bm2)+(Cm2*Bp2)) / (Bp2+Bm2));
				QL2ny[0][i2]=( (Cp2-Cm2)/(Bp2+Bm2) );
				if(fmodell==3)
				{	Js=(dx*fq(A[2],4*Rh[2],QL2[0][i2])*QL2[0][i2]*QL2[0][i2])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][i2]-QL2[0][i2]))-J2[0][i2]+Js);
					J2ny[0][i2]=J2[0][i2]+(djdt*dt);
																							}
				else
				{	J2ny[0][i2]=0;	}
			}

			//////////// Slutt Rr 2 /////////////

	//--------------  Node 3 uten sving  --------------//
			if(S1==0)
			{	if(fmodell==1)
				{	R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R3=(f*dx)/(2*g*4*Rh[3]*A[3]*A[3]);	}
				else if(fmodell==2)
				{	R2=(fq(A[2],4*Rh[2],QL2[0][I2])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R3=(fq(A[3],4*Rh[3],QL3[0][0])*dx)/(2*g*4*Rh[3]*A[3]*A[3]);}
				else if(fmodell==3)
				{	R2=0;
					R3=0;}

				Cp2=HL2[0][I2-1]+(B2*QL2[0][I2-1])-(g*J2[0][I2]);
				Bp2=B2+(R2*fabs(QL2[0][I2-1]));
				Cm3=HL3[0][1]-(B3*QL3[0][1])+(g*J3[0][0]);
				Bm3=B3+(R3*fabs(QL3[0][1]));
				float ScN3=(Cp2/Bp2)+(Cm3/Bm3);
				float SbN3=(1/Bp2)+(1/Bm3);
				float CnN3=ScN3/SbN3;
				float BnN3=1/SbN3;
				float Qn=0;
				float Hj=CnN3+(BnN3*Qn);
				HL2ny[0][I2]=Hj;
				HL3ny[0][0]=Hj;
				QL2ny[0][I2]=(Cp2-Hj)/Bp2;
				QL3ny[0][0]=(Hj-Cm3)/Bm3;
				if(fmodell==3)
				{	Js=(dx*fq(A[2],4*Rh[2],QL2[0][I2])*QL2[0][I2]*QL2[0][I2])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][I2]-QL2[0][I2]))-J2[0][I2]+Js);
					J2ny[0][I2]=J2[0][I2]+(djdt*dt);
					float Js3=(dx*fq(A[3],4*Rh[3],QL3[0][0])*QL3[0][0]*QL3[0][0])/(A[3]*A[3]*4*Rh[3]*2*g*g);
					float djdt3=(1/Y)*	(((K/(g*A[3]))*(QL3ny[0][0]-QL3[0][0]))-J3[0][0]+Js3);
					J3ny[0][0]=J3[0][0]+(djdt3*dt);
																							}
				else
				{	J2ny[0][I2]=0;
					J3ny[0][0]=0;}
			}
	//-------------Slutt node 3 uten sving--------------//

	//--------------  Node 3 med sving  --------------//
			if(S1==1)
			{	if(fmodell==1)
				{	R2=(f*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R3=(f*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
				else if(fmodell==2)
				{	R2=(fq(A[2],4*Rh[2],QL2[0][I2])*dx)/(2*g*4*Rh[2]*A[2]*A[2]);
					R3=(fq(A[3],4*Rh[3],QL3[0][0])*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					Rs1=(fq(As[1],4*rh[1],QLs1[0][0])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
				else if(fmodell==3)
				{	R2=0;
					R3=0;
					Rs1=0;}

				Cp2=HL2[0][I2-1]+(B2*QL2[0][I2-1])-(g*J2[0][I2]);
				Bp2=B2+(R2*fabs(QL2[0][I2-1]));
				Cm3=HL3[0][1]-(B3*QL3[0][1])+(g*J3[0][0]);
				Bm3=B3+(R3*fabs(QL3[0][1]));
				Cms1=HLs1[0][1]-(Bs1*QLs1[0][1])+(g*Js1[0][0]);
				Bms1=Bs1+(Rs1*fabs(QLs1[0][1]));
				float ScN3=(Cp2/Bp2)+(Cm3/Bm3)+(Cms1/Bms1);
				float SbN3=(1/Bp2)+(1/Bm3)+(1/Bms1);
				float CnN3=ScN3/SbN3;
				float BnN3=1/SbN3;
				float Qn=0;
				float Hj=CnN3+(BnN3*Qn);
				HLs1ny[0][0]=Hj;
				HL2ny[0][I2]=Hj;
				HL3ny[0][0]=Hj;
				QLs1ny[0][0]=(Hj-Cms1)/Bms1;
				QL2ny[0][I2]=(Cp2-Hj)/Bp2;
				QL3ny[0][0]=(Hj-Cm3)/Bm3;

				if(fmodell==3)
				{	Js=(dx*fq(A[2],4*Rh[2],QL2[0][I2])*QL2[0][I2]*QL2[0][I2])/(A[2]*A[2]*4*Rh[2]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[2]))*(QL2ny[0][I2]-QL2[0][I2]))-J2[0][I2]+Js);
					J2ny[0][I2]=J2[0][I2]+(djdt*dt);
					float Js3=(dx*fq(A[3],4*Rh[3],QL3[0][0])*QL3[0][0]*QL3[0][0])/(A[3]*A[3]*4*Rh[3]*2*g*g);
					float djdt3=(1/Y)*	(((K/(g*A[3]))*(QL3ny[0][0]-QL3[0][0]))-J3[0][0]+Js3);
					J3ny[0][0]=J3[0][0]+(djdt3*dt);
					float Jss1=(dx*fq(As[1],4*rh[1],QLs1[0][0])*QLs1[0][0]*QLs1[0][0])/(As[1]*As[1]*4*rh[1]*2*g*g);
					float djdts1=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][0]-QLs1[0][0]))-Js1[0][0]+Jss1);
					Js1ny[0][0]=Js1[0][0]+(djdts1*dt);
																							}
				else
				{	J2ny[0][I2]=0;
					J3ny[0][0]=0;
					Js1ny[0][0]=0;}

				/////////////////Start rr s1/////////////////////////
					for (is1=1;is1<Is1;is1++)
					{	if(fmodell==1)
						{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
						else if(fmodell==2)
						{	Rs1=(fq(As[1],4*rh[1],QLs1[0][is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
						else if(fmodell==3)
						{	Rs1=0;}

						Cps1=HLs1[0][is1-1]+(Bs1*QLs1[0][is1-1])-(g*Js1[0][is1]);
						Bps1=Bs1+(Rs1*fabs(QLs1[0][is1-1]));
						Cms1=HLs1[0][is1+1]-(Bs1*QLs1[0][is1+1])+(g*Js1[0][is1]);
						Bms1=Bs1+(Rs1*fabs(QLs1[0][is1+1]));
						HLs1ny[0][is1]=( ((Cps1*Bms1)+(Cms1*Bps1)) / (Bps1+Bms1));
						QLs1ny[0][is1]=( (Cps1-Cms1)/(Bps1+Bms1) );

					if(fmodell==3)
					{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][is1])*QLs1[0][is1]*QLs1[0][is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][is1]-QLs1[0][is1]))-Js1[0][is1]+Js);
						Js1ny[0][is1]=Js1[0][is1]+(djdt*dt);
																							}
					else
					{	Js1ny[0][is1]=0;}
				}

					if(fmodell==1)
					{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
					else if(fmodell==2)
					{	Rs1=(fq(As[1],4*rh[1],QLs1[0][Is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
					else if(fmodell==3)
					{	Rs1=0;}

					Cps1=HLs1[0][Is1-1]+(Bs1*QLs1[0][Is1-1])-(g*Js1[0][Is1]);
					Bps1=Bs1+(Rs1*fabs(QLs1[0][Is1-1]));
					QLs1ny[0][Is1]=(Cps1-HLs1[0][Is1])/Bps1;
					HLs1ny[0][Is1]=HLs1[0][Is1]+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);
					Z1=Z1+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);

					if(fmodell==3)
					{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][Is1])*QLs1[0][Is1]*QLs1[0][Is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][Is1]-QLs1[0][Is1]))-Js1[0][Is1]+Js);
						Js1ny[0][Is1]=Js1[0][Is1]+(djdt*dt);
																							}
					else
					{	Js1ny[0][Is1]=0;}
				////////////////Slutt rr s1//////////////////////////
			}
	//-------------Slutt node 3 med sving--------------//

			//////////// Start Rr 3 /////////////
			for (i3=1;i3<I3;i3++)
			{	if(fmodell==1)
				{	R3=(f*dx)/(2*g*4*Rh[3]*A[3]*A[3]);	}
				else if(fmodell==2)
				{	R3=(fq(A[3],4*Rh[3],QL3[0][i3])*dx)/(2*g*4*Rh[3]*A[3]*A[3]);}
				else if(fmodell==3)
				{	R3=0;}

				Cp3=HL3[0][i3-1]+(B3*QL3[0][i3-1])-(g*J3[0][i3]);
				Bp3=B3+(R3*fabs(QL3[0][i3-1]));
				Cm3=HL3[0][i3+1]-(B3*QL3[0][i3+1])+(g*J3[0][i3]);
				Bm3=B3+(R3*fabs(QL3[0][i3+1]));
				HL3ny[0][i3]=( ((Cp3*Bm3)+(Cm3*Bp3)) / (Bp3+Bm3));
				QL3ny[0][i3]=( (Cp3-Cm3)/(Bp3+Bm3) );

				if(fmodell==3)
				{	Js=(dx*fq(A[3],4*Rh[3],QL3[0][i3])*QL3[0][i3]*QL3[0][i3])/(A[3]*A[3]*4*Rh[3]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[3]))*(QL3ny[0][i3]-QL3[0][i3]))-J3[0][i3]+Js);
					J3ny[0][i3]=J3[0][i3]+(djdt*dt);
																						}
				else
				{	J3ny[0][i3]=0;}
			}

			//////////// Slutt Rr 3 /////////////

	//--------------- Node 4 uten sving  --------------------//
			if(S2==0)
			{	if(fmodell==1)
				{	R3=(f*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					R4=(f*dx)/(2*g*4*Rh[4]*A[4]*A[4]);	}
				else if(fmodell==2)
				{	R3=(fq(A[3],4*Rh[3],QL3[0][I3])*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					R4=(fq(A[4],4*Rh[4],QL4[0][0])*dx)/(2*g*4*Rh[4]*A[4]*A[4]);}
				else if(fmodell==3)
				{	R3=0;
					R4=0;}

				Cp3=HL3[0][I3-1]+(B3*QL3[0][I3-1])-(g*J3[0][I3]);
				Bp3=B3+(R3*fabs(QL3[0][I3-1]));
				Cm4=HL4[0][1]-(B4*QL4[0][1])+(g*J4[0][0]);
				Bm4=B4+(R4*fabs(QL4[0][1]));
				float ScN4=(Cp3/Bp3)+(Cm4/Bm4);
				float SbN4=(1/Bp3)+(1/Bm4);
				float CnN4=ScN4/SbN4;
				float BnN4=1/SbN4;
				float Qn=0;
				float Hj=CnN4+(BnN4*Qn);
				HL3ny[0][I3]=Hj;
				HL4ny[0][0]=Hj;
				QL3ny[0][I3]=(Cp3-Hj)/Bp3;
				QL4ny[0][0]=(Hj-Cm4)/Bm4;

				if(fmodell==3)
				{	Js=(dx*fq(A[3],4*Rh[3],QL3[0][I3])*QL3[0][I3]*QL3[0][I3])/(A[3]*A[3]*4*Rh[3]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[3]))*(QL3ny[0][I3]-QL3[0][I3]))-J3[0][I3]+Js);
					J3ny[0][I3]=J3[0][I3]+(djdt*dt);
					float Js4=(dx*fq(A[4],4*Rh[4],QL4[0][0])*QL4[0][0]*QL4[0][0])/(A[4]*A[4]*4*Rh[4]*2*g*g);
					float djdt4=(1/Y)*	(((K/(g*A[4]))*(QL4ny[0][0]-QL4[0][0]))-J4[0][0]+Js4);
					J4ny[0][0]=J4[0][0]+(djdt4*dt);
																						}
				else
				{	J3ny[0][I3]=0;
					J4ny[0][0]=0;}
			}
	//---------------- Slutt node 4 uten sving ---------------//

	//--------------- Node 4 med sving  --------------------//
			if(S2==1)
			{	if(fmodell==1)
				{	R3=(f*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					R4=(f*dx)/(2*g*4*Rh[4]*A[4]*A[4]);
					R11=(f*dx)/(2*g*4*Rh[11]*A[11]*A[11]);}
				else if(fmodell==2)
				{	R3=(fq(A[3],4*Rh[3],QL3[0][I3])*dx)/(2*g*4*Rh[3]*A[3]*A[3]);
					R4=(fq(A[4],4*Rh[4],QL4[0][0])*dx)/(2*g*4*Rh[4]*A[4]*A[4]);
					R11=(fq(A[11],4*Rh[11],QL11[0][0])*dx)/(2*g*4*Rh[11]*A[11]*A[11]);}
				else if(fmodell==3)
				{	R3=0;
					R4=0;
					R11=0;}

				Cp3=HL3[0][I3-1]+(B3*QL3[0][I3-1])-(g*J3[0][I3]);
				Bp3=B3+(R3*fabs(QL3[0][I3-1]));
				Cm4=HL4[0][1]-(B4*QL4[0][1])+(g*J4[0][0]);
				Bm4=B4+(R4*fabs(QL4[0][1]));
				Cm11=HL11[0][1]-(B11*QL11[0][1])+(g*J11[0][0]);
				Bm11=B11+(R11*fabs(QL11[0][1]));
				float ScN4=(Cp3/Bp3)+(Cm4/Bm4)+(Cm11/Bm11);
				float SbN4=(1/Bp3)+(1/Bm4)+(1/Bm11);
				float CnN4=ScN4/SbN4;
				float BnN4=1/SbN4;
				float Qn=0;
				float Hj=CnN4+(BnN4*Qn);
				HL11ny[0][0]=Hj;
				HL3ny[0][I3]=Hj;
				HL4ny[0][0]=Hj;
				QL11ny[0][0]=(Hj-Cm11)/Bm11;
				QL3ny[0][I3]=(Cp3-Hj)/Bp3;
				QL4ny[0][0]=(Hj-Cm4)/Bm4;

				if(fmodell==3)
				{	Js=(dx*fq(A[3],4*Rh[3],QL3[0][I3])*QL3[0][I3]*QL3[0][I3])/(A[3]*A[3]*4*Rh[3]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[3]))*(QL3ny[0][I3]-QL3[0][I3]))-J3[0][I3]+Js);
					J3ny[0][I3]=J3[0][I3]+(djdt*dt);
					float Js4=(dx*fq(A[4],4*Rh[4],QL4[0][0])*QL4[0][0]*QL4[0][0])/(A[4]*A[4]*4*Rh[4]*2*g*g);
					float djdt4=(1/Y)*	(((K/(g*A[4]))*(QL4ny[0][0]-QL4[0][0]))-J4[0][0]+Js4);
					J4ny[0][0]=J4[0][0]+(djdt4*dt);
					float Js11=(dx*fq(A[11],4*Rh[11],QL11[0][0])*QL11[0][0]*QL11[0][0])/(A[11]*A[11]*4*Rh[11]*2*g*g);
					float djdt11=(1/Y)*	(((K/(g*A[11]))*(QL11ny[0][0]-QL11[0][0]))-J11[0][0]+Js11);
					J11ny[0][0]=J11[0][0]+(djdt11*dt);
																						}
				else
				{	J3ny[0][I3]=0;
					J4ny[0][0]=0;
					J11ny[0][0]=0;}

					//////////// Start Rr 11 /////////////
				for (i11=1;i11<I11;i11++)
				{	if(fmodell==1)
					{	R11=(f*dx)/(2*g*4*Rh[11]*A[11]*A[11]);	}
					else if(fmodell==2)
					{	R11=(fq(A[11],4*Rh[11],QL11[0][i11])*dx)/(2*g*4*Rh[11]*A[11]*A[11]);}
					else if(fmodell==3)
					{	R11=0;}

					Cp11=HL11[0][i11-1]+(B11*QL11[0][i11-1])-(g*J11[0][i11]);
					Bp11=B11+(R11*fabs(QL11[0][i11-1]));
					Cm11=HL11[0][i11+1]-(B11*QL11[0][i11+1])+(g*J11[0][i11]);
					Bm11=B11+(R11*fabs(QL11[0][i11+1]));
					HL11ny[0][i11]=( ((Cp11*Bm11)+(Cm11*Bp11)) / (Bp11+Bm11));
					QL11ny[0][i11]=( (Cp11-Cm11)/(Bp11+Bm11) );

					if(fmodell==3)
					{	Js=(dx*fq(A[11],4*Rh[11],QL11[0][i11])*QL11[0][i11]*QL11[0][i11])/(A[11]*A[11]*4*Rh[11]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[11]))*(QL11ny[0][i11]-QL11[0][i11]))-J11[0][i11]+Js);
						J11ny[0][i11]=J11[0][i11]+(djdt*dt);
																							}
					else
					{	J11ny[0][i11]=0;}
				}
				//////////// Slutt Rr 11 /////////////
	//--------------------- Node s5 ---------------------------//
				if(H0>0)								//Fungerer ikke om if-setning fjernes, derfor
				{	if(fmodell==1)
					{	R11=(f*dx)/(2*g*4*Rh[11]*A[11]*A[11]);	//sprres det om if for noe som alltid er sant
						R12=(f*dx)/(2*g*4*Rh[12]*A[12]*A[12]);	}
					else if(fmodell==2)
					{	R11=(fq(A[11],4*Rh[11],QL11[0][I11])*dx)/(2*g*4*Rh[11]*A[11]*A[11]);
						R12=(fq(A[12],4*Rh[12],QL12[0][0])*dx)/(2*g*4*Rh[12]*A[12]*A[12]);}
					else if(fmodell==3)
					{	R11=0;
						R12=0;}

					Cp11=HL11[0][I11-1]+(B11*QL11[0][I11-1])-(g*J11[0][I11]);
					Bp11=B11+(R11*fabs(QL11[0][I11-1]));
					Cm12=HL12[0][1]-(B12*QL12[0][1])+(g*J12[0][0]);
					Bm12=B12+(R12*fabs(QL12[0][1]));
					float ScNs5=(Cp11/Bp11)+(Cm12/Bm12);
					float SbNs5=(1/Bp11)+(1/Bm12);
					float CnNs5=ScNs5/SbNs5;
					float BnNs5=1/SbNs5;
					float Qn=0;
					float Hj=CnNs5+(BnNs5*Qn);
					HL11ny[0][I11]=Hj;
					HL12ny[0][0]=Hj;
					QL11ny[0][I11]=(Cp11-Hj)/Bp11;
					QL12ny[0][0]=(Hj-Cm12)/Bm12;

					if(fmodell==3)
					{	Js=(dx*fq(A[11],4*Rh[11],QL11[0][I11])*QL11[0][I11]*QL11[0][I11])/(A[11]*A[11]*4*Rh[11]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[11]))*(QL11ny[0][I11]-QL11[0][I11]))-J11[0][I11]+Js);
						J11ny[0][I11]=J11[0][I11]+(djdt*dt);
						float Js12=(dx*fq(A[12],4*Rh[12],QL12[0][0])*QL12[0][0]*QL12[0][0])/(A[12]*A[12]*4*Rh[12]*2*g*g);
						float djdt12=(1/Y)*	(((K/(g*A[12]))*(QL12ny[0][0]-QL12[0][0]))-J12[0][0]+Js12);
						J12ny[0][0]=J12[0][0]+(djdt12*dt);
																						}
					else
					{	J11ny[0][I11]=0;
						J12ny[0][0]=0;}
				}

	//------------------- Slutt node s5 -----------------------//

					//////////// Start Rr 12 /////////////
				for (i12=1;i12<I12;i12++)
				{	if(fmodell==1)
					{	R12=(f*dx)/(2*g*4*Rh[12]*A[12]*A[12]);	}
					else if(fmodell==2)
					{	R12=(fq(A[12],4*Rh[12],QL12[0][i12])*dx)/(2*g*4*Rh[12]*A[12]*A[12]);}
					else if(fmodell==3)
					{	R12=0;}

					Cp12=HL12[0][i12-1]+(B12*QL12[0][i12-1])-(g*J12[0][i12]);
					Bp12=B12+(R12*fabs(QL12[0][i12-1]));
					Cm12=HL12[0][i12+1]-(B12*QL12[0][i12+1])+(g*J12[0][i12]);
					Bm12=B12+(R12*fabs(QL12[0][i12+1]));
					HL12ny[0][i12]=( ((Cp12*Bm12)+(Cm12*Bp12)) / (Bp12+Bm12));
					QL12ny[0][i12]=( (Cp12-Cm12)/(Bp12+Bm12) );

					if(fmodell==3)
					{	Js=(dx*fq(A[12],4*Rh[12],QL12[0][i12])*QL12[0][i12]*QL12[0][i12])/(A[12]*A[12]*4*Rh[12]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[12]))*(QL12ny[0][i12]-QL12[0][i12]))-J12[0][i12]+Js);
						J12ny[0][i12]=J12[0][i12]+(djdt*dt);
																							}
					else
					{	J12ny[0][i12]=0;}
				}
				//////////// Slutt Rr 12 /////////////

	//--------------------- Node s6 ---------------------------//
				if(H0>0)								//Fungerer ikke om if-setning fjernes, derfor
				{	if(fmodell==1)
					{	R12=(f*dx)/(2*g*4*Rh[12]*A[12]*A[12]);	//sprres det om if for noe som alltid er sant
						Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
					else if(fmodell==2)
					{	R12=(fq(A[12],4*Rh[12],QL12[0][I12])*dx)/(2*g*4*Rh[12]*A[12]*A[12]);
						Rs1=(fq(As[1],4*rh[1],QLs1[0][0])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
					else if(fmodell==3)
					{	R12=0;
						Rs1=0;}

					Cp12=HL12[0][I12-1]+(B12*QL12[0][I12-1])-(g*J12[0][I12]);
					Bp12=B12+(R12*fabs(QL12[0][I12-1]));
					Cms1=HLs1[0][1]-(Bs1*QLs1[0][1])+(g*Js1[0][0]);
					Bms1=Bs1+(Rs1*fabs(QLs1[0][1]));
					float ScNs6=(Cp12/Bp12)+(Cms1/Bms1);
					float SbNs6=(1/Bp12)+(1/Bms1);
					float CnNs6=ScNs6/SbNs6;
					float BnNs6=1/SbNs6;
					float Qn=0;
					float Hj=CnNs6+(BnNs6*Qn);
					HL12ny[0][I12]=Hj;
					HLs1ny[0][0]=Hj;
					QL12ny[0][I12]=(Cp12-Hj)/Bp12;
					QLs1ny[0][0]=(Hj-Cms1)/Bms1;

					if(fmodell==3)
					{	Js=(dx*fq(A[12],4*Rh[12],QL12[0][I12])*QL12[0][I12]*QL12[0][I12])/(A[12]*A[12]*4*Rh[12]*2*g*g);
						djdt=(1/Y)*	(((K/(g*A[12]))*(QL12ny[0][I12]-QL12[0][I12]))-J12[0][I12]+Js);
						J12ny[0][I12]=J12[0][I12]+(djdt*dt);
						float Jss1=(dx*fq(As[1],4*rh[1],QLs1[0][0])*QLs1[0][0]*QLs1[0][0])/(As[1]*As[1]*4*rh[1]*2*g*g);
						float djdts1=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][0]-QLs1[0][0]))-Js1[0][0]+Jss1);
						Js1ny[0][0]=Js1[0][0]+(djdts1*dt);
																						}
					else
					{	J12ny[0][I12]=0;
						Js1ny[0][0]=0;}
				}

	//------------------- Slutt node s6 -----------------------//

				/////////////////Start rr s1/////////////////////////
				for (is1=1;is1<Is1;is1++)
				{	if(fmodell==1)
					{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
					else if(fmodell==2)
					{	Rs1=(fq(As[1],4*rh[1],QLs1[0][is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
					else if(fmodell==3)
					{	Rs1=0;}

					Cps1=HLs1[0][is1-1]+(Bs1*QLs1[0][is1-1])-(g*Js1[0][is1]);
					Bps1=Bs1+(Rs1*fabs(QLs1[0][is1-1]));
					Cms1=HLs1[0][is1+1]-(Bs1*QLs1[0][is1+1])+(g*Js1[0][is1]);
					Bms1=Bs1+(Rs1*fabs(QLs1[0][is1+1]));
					HLs1ny[0][is1]=( ((Cps1*Bms1)+(Cms1*Bps1)) / (Bps1+Bms1));
					QLs1ny[0][is1]=( (Cps1-Cms1)/(Bps1+Bms1) );

					if(fmodell==3)
					{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][is1])*QLs1[0][is1]*QLs1[0][is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][is1]-QLs1[0][is1]))-Js1[0][is1]+Js);
						Js1ny[0][is1]=Js1[0][is1]+(djdt*dt);
																							}
					else
					{	Js1ny[0][is1]=0;}
				}

					if(fmodell==1)
					{	Rs1=(f*dx)/(2*g*4*rh[1]*As[1]*As[1]);	}
					else if(fmodell==2)
					{	Rs1=(fq(As[1],4*rh[1],QLs1[0][Is1])*dx)/(2*g*4*rh[1]*As[1]*As[1]);}
					else if(fmodell==3)
					{	Rs1=0;}

					Cps1=HLs1[0][Is1-1]+(Bs1*QLs1[0][Is1-1])-(g*Js1[0][Is1]);
					Bps1=Bs1+(Rs1*fabs(QLs1[0][Is1-1]));
					QLs1ny[0][Is1]=(Cps1-HLs1[0][Is1])/Bps1;
					HLs1ny[0][Is1]=HLs1[0][Is1]+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);
					Z1=Z1+((QLs1ny[0][Is1]/Arealsjakt(Z1))*dt);

					if(fmodell==3)
					{	Js=(dx*fq(As[1],4*rh[1],QLs1[0][Is1])*QLs1[0][Is1]*QLs1[0][Is1])/(As[1]*As[1]*4*rh[1]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[1]))*(QLs1ny[0][Is1]-QLs1[0][Is1]))-Js1[0][Is1]+Js);
						Js1ny[0][Is1]=Js1[0][Is1]+(djdt*dt);
																							}
					else
					{	Js1ny[0][Is1]=0;}
				////////////////Slutt rr s1//////////////////////////
			}
	//---------------- Slutt node 4 med sving ---------------//

			//////////// Start Rr 4 /////////////
			for (i4=1;i4<I4;i4++)
			{	if(fmodell==1)
				{	R4=(f*dx)/(2*g*4*Rh[4]*A[4]*A[4]);	}
				else if(fmodell==2)
				{	R4=(fq(A[4],4*Rh[4],QL4[0][i4])*dx)/(2*g*4*Rh[4]*A[4]*A[4]);}
				else if(fmodell==3)
				{	R4=0;}

				Cp4=HL4[0][i4-1]+(B4*QL4[0][i4-1])-(g*J4[0][i4]);
				Bp4=B4+(R4*fabs(QL4[0][i4-1]));
				Cm4=HL4[0][i4+1]-(B4*QL4[0][i4+1])+(g*J4[0][i4]);
				Bm4=B4+(R4*fabs(QL4[0][i4+1]));
				HL4ny[0][i4]=( ((Cp4*Bm4)+(Cm4*Bp4)) / (Bp4+Bm4));
				QL4ny[0][i4]=( (Cp4-Cm4)/(Bp4+Bm4) );

				if(fmodell==3)
				{	Js=(dx*fq(A[4],4*Rh[4],QL4[0][i4])*QL4[0][i4]*QL4[0][i4])/(A[4]*A[4]*4*Rh[4]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[4]))*(QL4ny[0][i4]-QL4[0][i4]))-J4[0][i4]+Js);
					J4ny[0][i4]=J4[0][i4]+(djdt*dt);
																						}
				else
				{	J4ny[0][i4]=0;}
			}
			//////////// Slutt Rr 4 /////////////

	//--------------------- Node 5 ---------------------------//
			if(H0>0)								//Fungerer ikke om if-setning fjernes, derfor
			{	if(fmodell==1)
				{	R4=(f*dx)/(2*g*4*Rh[4]*A[4]*A[4]);	//sprres det om if for noe som alltid er sant
					R5=(f*dx)/(2*g*4*Rh[5]*A[5]*A[5]);	}
				else if(fmodell==2)
				{	R4=(fq(A[4],4*Rh[4],QL4[0][I4])*dx)/(2*g*4*Rh[4]*A[4]*A[4]);
					R5=(fq(A[5],4*Rh[5],QL5[0][0])*dx)/(2*g*4*Rh[5]*A[5]*A[5]);}
				else if(fmodell==3)
				{	R4=0;
					R5=0;}

				Cp4=HL4[0][I4-1]+(B4*QL4[0][I4-1])-(g*J4[0][I4]);
				Bp4=B4+(R4*fabs(QL4[0][I4-1]));
				Cm5=HL5[0][1]-(B5*QL5[0][1])+(g*J5[0][0]);
				Bm5=B5+(R5*fabs(QL5[0][1]));
				float ScN5=(Cp4/Bp4)+(Cm5/Bm5);
				float SbN5=(1/Bp4)+(1/Bm5);
				float CnN5=ScN5/SbN5;
				float BnN5=1/SbN5;
				float Qn=0;
				float Hj=CnN5+(BnN5*Qn);
				HL4ny[0][I4]=Hj;
				HL5ny[0][0]=Hj;
				QL4ny[0][I4]=(Cp4-Hj)/Bp4;
				QL5ny[0][0]=(Hj-Cm5)/Bm5;

				if(fmodell==3)
				{	Js=(dx*fq(A[4],4*Rh[4],QL4[0][I4])*QL4[0][I4]*QL4[0][I4])/(A[4]*A[4]*4*Rh[4]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[4]))*(QL4ny[0][I4]-QL4[0][I4]))-J4[0][I4]+Js);
					J4ny[0][I4]=J4[0][I4]+(djdt*dt);
					float Js5=(dx*fq(A[5],4*Rh[5],QL5[0][0])*QL5[0][0]*QL5[0][0])/(A[5]*A[5]*4*Rh[5]*2*g*g);
					float djdt5=(1/Y)*	(((K/(g*A[5]))*(QL5ny[0][0]-QL5[0][0]))-J5[0][0]+Js5);
					J5ny[0][0]=J5[0][0]+(djdt5*dt);
																						}
				else
				{	J4ny[0][I4]=0;
					J5ny[0][0]=0;}
			}

	//------------------- Slutt node 5 -----------------------//

			//////////// Start Rr 5 /////////////
			for (i5=1;i5<I5;i5++)
			{	if(fmodell==1)
				{	R5=(f*dx)/(2*g*4*Rh[5]*A[5]*A[5]);	}
				else if(fmodell==2)
				{	R5=(fq(A[5],4*Rh[5],QL5[0][i5])*dx)/(2*g*4*Rh[5]*A[5]*A[5]);}
				else if(fmodell==3)
				{	R5=0;}

				Cp5=HL5[0][i5-1]+(B5*QL5[0][i5-1])-(g*J5[0][i5]);
				Bp5=B5+(R5*fabs(QL5[0][i5-1]));
				Cm5=HL5[0][i5+1]-(B5*QL5[0][i5+1])+(g*J5[0][i5]);
				Bm5=B5+(R5*fabs(QL5[0][i5+1]));
				HL5ny[0][i5]=( ((Cp5*Bm5)+(Cm5*Bp5)) / (Bp5+Bm5));
				QL5ny[0][i5]=( (Cp5-Cm5)/(Bp5+Bm5) );

				if(fmodell==3)
				{	Js=(dx*fq(A[5],4*Rh[5],QL5[0][i5])*QL5[0][i5]*QL5[0][i5])/(A[5]*A[5]*4*Rh[5]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[5]))*(QL5ny[0][i5]-QL5[0][i5]))-J5[0][i5]+Js);
					J5ny[0][i5]=J5[0][i5]+(djdt*dt);
																						}
				else
				{	J5ny[0][i5]=0;}
			}

			//////////// Slutt Rr 5 /////////////

			//////////// Start ventil ///////////
				if(fmodell==1)
				{	R5=(f*dx)/(2*g*4*Rh[5]*A[5]*A[5]);
					R6=(f*dx)/(2*g*4*Rh[6]*A[6]*A[6]);}
				else if(fmodell==2)
				{	R5=(fq(A[5],4*Rh[5],QL5[0][I5])*dx)/(2*g*4*Rh[5]*A[5]*A[5]);
					R6=(fq(A[6],4*Rh[6],QL6[0][0])*dx)/(2*g*4*Rh[6]*A[6]*A[6]);}
				else if(fmodell==3)
				{	R5=0;
					R6=0;}

				Cp5=HL5[0][I5-1]+(B5*QL5[0][I5-1])-(g*J5[0][I5]);
				Bp5=B5+(R5*fabs(QL5[0][I5-1]));
				Cm6=HL6[0][1]-(B6*QL6[0][1])+(g*J6[0][0]);
				Bm6=B6+(R6*fabs(QL6[0][1]));
				float Cv=pow(Qn*Kstilling(t,Tl,Tavslag,Tpadrag,simtyp),2)/(2*Hn);
				if(HL5[0][I5]>=HL6[0][0])								//Positiv strmningsretning
				{	QL5ny[0][I5]=(-Cv*(Bp5+Bm6))+sqrt(pow((Bp5+Bm6)*Cv,2)+(2*Cv*(Cp5-Cm6)));	}
				else if(HL5[0][I5]<HL6[0][0])							//Negativ strmningsretning
				{	QL5ny[0][I5]=(Cv*(Bp5+Bm6))-sqrt(pow((Bp5+Bm6)*Cv,2)-(2*Cv*(Cp5-Cm6)));	}
				HL5ny[0][I5]=Cp5-(Bp5*QL5ny[0][I5]);
				QL6ny[0][0]=QL5ny[0][I5];
				HL6ny[0][0]=Cm6+(Bm6*QL6ny[0][0]);
				fprintf(Kstil,"%f\t%f\n",j*dt,Kstilling(t,Tl,Tavslag,Tpadrag,simtyp));

				if(fmodell==3)
				{	Js=(dx*fq(A[5],4*Rh[5],QL5[0][I5])*QL5[0][I5]*QL5[0][I5])/(A[5]*A[5]*4*Rh[5]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[5]))*(QL5ny[0][I5]-QL5[0][I5]))-J5[0][I5]+Js);
					J5ny[0][I5]=J5[0][I5]+(djdt*dt);
					float Js6=(dx*fq(A[6],4*Rh[6],QL6[0][0])*QL6[0][0]*QL6[0][0])/(A[6]*A[6]*4*Rh[6]*2*g*g);
					float djdt6=(1/Y)*	(((K/(g*A[6]))*(QL6ny[0][0]-QL6[0][0]))-J6[0][0]+Js6);
					J6ny[0][0]=J6[0][0]+(djdt6*dt);
																						}
				else
				{	J5ny[0][I5]=0;
					J6ny[0][0]=0;}
			//////////// Slutt ventil ///////////

			////////////// Rr 6 ////////////////
			for(i6=1;i6<I6;i6++)
			{	Cp6=HL6[0][i6-1]+(B6*QL6[0][i6-1])-(g*J6[0][i6]);
				Bp6=B6+(R6*fabs(QL6[0][i6-1]));
				Cm6=HL6[0][i6+1]-(B6*QL6[0][i6+1])+(g*J6[0][i6]);
				Bm6=B6+(R6*fabs(QL6[0][i6+1]));
				HL6ny[0][i6]=( ((Cp6*Bm6)+(Cm6*Bp6)) / (Bp6+Bm6));
				QL6ny[0][i6]=( (Cp6-Cm6)/(Bp6+Bm6) );

				if(fmodell==3)
				{	Js=(dx*fq(A[6],4*Rh[6],QL6[0][0])*QL6[0][0]*QL6[0][0])/(A[6]*A[6]*4*Rh[6]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[6]))*(QL6ny[0][0]-QL6[0][0]))-J6[0][0]+Js);
					J6ny[0][i6]=J6[0][0]+(djdt*dt);
																							}
				else
				{	J6ny[0][i6]=0;}
			}
			////////////Slutt Rr 6 /////////////

	//--------------------- Node 8 ---------------------------//
			if(H0>0)								//Fungerer ikke om if-setning fjernes, derfor
			{	if(fmodell==1)						//sprres det om if for noe som alltid er sant
				{	R6=(f*dx)/(2*g*4*Rh[6]*A[6]*A[6]);
					R7=(f*dx)/(2*g*4*Rh[7]*A[7]*A[7]);	}
				else if(fmodell==2)
				{	R6=(fq(A[6],4*Rh[6],QL6[0][I6])*dx)/(2*g*4*Rh[6]*A[6]*A[6]);
					R7=(fq(A[7],4*Rh[7],QL7[0][0])*dx)/(2*g*4*Rh[7]*A[7]*A[7]);}
				else if(fmodell==3)
				{	R6=0;
					R7=0;}

				Cp6=HL6[0][I6-1]+(B6*QL6[0][I6-1])-(g*J6[0][I6]);
				Bp6=B6+(R6*fabs(QL6[0][I6-1]));
				Cm7=HL7[0][1]-(B7*QL7[0][1])+(g*J7[0][0]);
				Bm7=B7+(R7*fabs(QL7[0][1]));
				float ScN8=(Cp6/Bp6)+(Cm7/Bm7);
				float SbN8=(1/Bp6)+(1/Bm7);
				float CnN8=ScN8/SbN8;
				float BnN8=1/SbN8;
				float Qn=0;
				float Hj=CnN8+(BnN8*Qn);
				HL6ny[0][I6]=Hj;
				HL7ny[0][0]=Hj;
				QL6ny[0][I6]=(Cp6-Hj)/Bp6;
				QL7ny[0][0]=(Hj-Cm7)/Bm7;

				if(fmodell==3)
				{	Js=(dx*fq(A[6],4*Rh[6],QL6[0][I6])*QL6[0][I6]*QL6[0][I6])/(A[6]*A[6]*4*Rh[6]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[6]))*(QL6ny[0][I6]-QL6[0][I6]))-J6[0][I6]+Js);
					J6ny[0][I6]=J6[0][I6]+(djdt*dt);
					float Js7=(dx*fq(A[7],4*Rh[7],QL7[0][0])*QL7[0][0]*QL7[0][0])/(A[7]*A[7]*4*Rh[7]*2*g*g);
					float djdt7=(1/Y)*	(((K/(g*A[7]))*(QL7ny[0][0]-QL7[0][0]))-J7[0][0]+Js7);
					J7ny[0][0]=J7[0][0]+(djdt7*dt);
																						}
				else
				{	J6ny[0][I6]=0;
					J7ny[0][0]=0;}
			}
	//------------------ Slutt Node 8 ------------------------//

			//////////// Start Rr 7 /////////////
			for (i7=1;i7<I7;i7++)
			{	if(fmodell==1)
				{	R7=(f*dx)/(2*g*4*Rh[7]*A[7]*A[7]);	}
				else if(fmodell==2)
				{	R7=(fq(A[7],4*Rh[7],QL7[0][i7])*dx)/(2*g*4*Rh[7]*A[7]*A[7]);}
				else if(fmodell==3)
				{	R7=0;}

				Cp7=HL7[0][i7-1]+(B7*QL7[0][i7-1])-(g*J7[0][i7]);
				Bp7=B7+(R7*fabs(QL7[0][i7-1]));
				Cm7=HL7[0][i7+1]-(B7*QL7[0][i7+1])+(g*J7[0][i7]);
				Bm7=B7+(R7*fabs(QL7[0][i7+1]));
				HL7ny[0][i7]=( ((Cp7*Bm7)+(Cm7*Bp7)) / (Bp7+Bm7));
				QL7ny[0][i7]=( (Cp7-Cm7)/(Bp7+Bm7) );

				if(fmodell==3)
				{	Js=(dx*fq(A[7],4*Rh[7],QL7[0][i7])*QL7[0][i7]*QL7[0][i7])/(A[7]*A[7]*4*Rh[7]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[7]))*(QL7ny[0][i7]-QL7[0][i7]))-J7[0][i7]+Js);
					J7ny[0][i7]=J7[0][i7]+(djdt*dt);
																						}
				else
				{	J7ny[0][i7]=0;}
			}
			//////////// Slutt Rr 7 /////////////

	//--------------- Node 9 uten sving  --------------------//
			if(S4==0)
			{	if(fmodell==1)
				{	R7=(f*dx)/(2*g*4*Rh[7]*A[7]*A[7]);
					R8=(f*dx)/(2*g*4*Rh[8]*A[8]*A[8]);	}
				else if(fmodell==2)
				{	R7=(fq(A[7],4*Rh[7],QL7[0][I7])*dx)/(2*g*4*Rh[7]*A[7]*A[7]);
					R8=(fq(A[8],4*Rh[8],QL8[0][0])*dx)/(2*g*4*Rh[8]*A[8]*A[8]);}
				else if(fmodell==3)
				{	R7=0;
					R8=0;}

				Cp7=HL7[0][I7-1]+(B7*QL7[0][I7-1])-(g*J7[0][I7]);
				Bp7=B7+(R7*fabs(QL7[0][I7-1]));
				Cm8=HL8[0][1]-(B8*QL8[0][1])+(g*J8[0][0]);
				Bm8=B8+(R8*fabs(QL8[0][1]));
				float ScN9=(Cp7/Bp7)+(Cm8/Bm8);
				float SbN9=(1/Bp7)+(1/Bm8);
				float CnN9=ScN9/SbN9;
				float BnN9=1/SbN9;
				float Qn=0;
				float Hj=CnN9+(BnN9*Qn);
				HL7ny[0][I7]=Hj;
				HL8ny[0][0]=Hj;
				QL7ny[0][I7]=(Cp7-Hj)/Bp7;
				QL8ny[0][0]=(Hj-Cm8)/Bm8;

				if(fmodell==3)
				{	Js=(dx*fq(A[7],4*Rh[7],QL7[0][I7])*QL7[0][I7]*QL7[0][I7])/(A[7]*A[7]*4*Rh[7]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[7]))*(QL7ny[0][I7]-QL7[0][I7]))-J7[0][I7]+Js);
					J7ny[0][I7]=J7[0][I7]+(djdt*dt);
					float Js8=(dx*fq(A[8],4*Rh[8],QL8[0][0])*QL8[0][0]*QL8[0][0])/(A[8]*A[8]*4*Rh[8]*2*g*g);
					float djdt8=(1/Y)*	(((K/(g*A[8]))*(QL8ny[0][0]-QL8[0][0]))-J8[0][0]+Js8);
					J8ny[0][0]=J8[0][0]+(djdt8*dt);
																						}
				else
				{	J7ny[0][I7]=0;
					J8ny[0][0]=0;}
			}
	//---------------- Slutt node 9 uten sving ---------------//

	//--------------- Node 9 med sving  --------------------//
			else if(S4==1)
			{	if(fmodell==1)
				{	R7=(f*dx)/(2*g*4*Rh[7]*A[7]*A[7]);
					R8=(f*dx)/(2*g*4*Rh[8]*A[8]*A[8]);
					Rs2=(f*dx)/(2*g*4*rh[2]*As[2]*As[2]);}
				else if(fmodell==2)
				{	R7=(fq(A[7],4*Rh[7],QL7[0][I7])*dx)/(2*g*4*Rh[7]*A[7]*A[7]);
					R8=(fq(A[8],4*Rh[8],QL8[0][0])*dx)/(2*g*4*Rh[8]*A[8]*A[8]);
					Rs2=(fq(As[2],4*rh[2],QLs2[0][0])*dx)/(2*g*4*rh[2]*As[2]*As[2]);}
				else if(fmodell==3)
				{	R7=0;
					R8=0;
					Rs2=0;}

				Cp7=HL7[0][I7-1]+(B7*QL7[0][I7-1])-(g*J7[0][I7]);
				Bp7=B7+(R7*fabs(QL7[0][I7-1]));
				Cm8=HL8[0][1]-(B8*QL8[0][1])+(g*J8[0][0]);
				Bm8=B8+(R8*fabs(QL8[0][1]));
				Cms2=HLs2[0][1]-(Bs2*QLs2[0][1])+(g*Js2[0][0]);
				Bms2=Bs2+(Rs2*fabs(QLs2[0][1]));
				float ScN9=(Cp7/Bp7)+(Cm8/Bm8)+(Cms2/Bms2);
				float SbN9=(1/Bp7)+(1/Bm8)+(1/Bms2);
				float CnN9=ScN9/SbN9;
				float BnN9=1/SbN9;
				float Qn=0;
				float Hj=CnN9+(BnN9*Qn);
				HLs2ny[0][0]=Hj;
				HL7ny[0][I7]=Hj;
				HL8ny[0][0]=Hj;
				QLs2ny[0][0]=(Hj-Cms2)/Bms2;
				QL7ny[0][I7]=(Cp7-Hj)/Bp7;
				QL8ny[0][0]=(Hj-Cm8)/Bm8;

				if(fmodell==3)
				{	Js=(dx*fq(A[7],4*Rh[7],QL7[0][I7])*QL7[0][I7]*QL7[0][I7])/(A[7]*A[7]*4*Rh[7]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[7]))*(QL7ny[0][I7]-QL7[0][I7]))-J7[0][I7]+Js);
					J7ny[0][I7]=J7[0][I7]+(djdt*dt);
					float Js8=(dx*fq(A[8],4*Rh[8],QL8[0][0])*QL8[0][0]*QL8[0][0])/(A[8]*A[8]*4*Rh[8]*2*g*g);
					float djdt8=(1/Y)*	(((K/(g*A[8]))*(QL8ny[0][0]-QL8[0][0]))-J8[0][0]+Js8);
					J8ny[0][0]=J8[0][0]+(djdt8*dt);
					float Jss2=(dx*fq(As[2],4*rh[2],QLs2[0][0])*QLs2[0][0]*QLs2[0][0])/(As[2]*As[2]*4*rh[2]*2*g*g);
					float djdts2=(1/Y)*	(((K/(g*As[2]))*(QLs2ny[0][0]-QLs2[0][0]))-Js2[0][0]+Jss2);
					Js2ny[0][0]=Js2[0][0]+(djdts2*dt);
																						}
				else
				{	J7ny[0][I7]=0;
					J8ny[0][0]=0;
					Js2ny[0][0]=0;}

				/////////////////Start rr s2/////////////////////////
				for (is2=1;is2<Is2;is2++)
				{	if(fmodell==1)
					{	Rs2=(f*dx)/(2*g*4*rh[2]*As[2]*As[2]);	}
					else if(fmodell==2)
					{	Rs2=(fq(As[2],4*rh[2],QLs2[0][is2])*dx)/(2*g*4*rh[2]*As[2]*As[2]);}
					else if(fmodell==3)
					{	Rs2=0;}

					Cps2=HLs2[0][is2-1]+(Bs2*QLs2[0][is2-1])-(g*Js2[0][is2]);
					Bps2=Bs2+(Rs2*fabs(QLs2[0][is2-1]));
					Cms2=HLs2[0][is2+1]-(Bs2*QLs2[0][is2+1])+(g*Js2[0][is2]);
					Bms2=Bs2+(Rs2*fabs(QLs2[0][is2+1]));
					HLs2ny[0][is2]=( ((Cps2*Bms2)+(Cms2*Bps2)) / (Bps2+Bms2));
					QLs2ny[0][is2]=( (Cps2-Cms2)/(Bps2+Bms2) );

					if(fmodell==3)
					{	Js=(dx*fq(As[2],4*rh[2],QLs2[0][is2])*QLs2[0][is2]*QLs2[0][is2])/(As[2]*As[2]*4*rh[2]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[2]))*(QLs2ny[0][is2]-QLs2[0][is2]))-Js2[0][is2]+Js);
						Js2ny[0][is2]=Js2[0][is2]+(djdt*dt);
																							}
					else
					{	Js2ny[0][is2]=0;}
				}

					if(fmodell==1)
					{	Rs2=(f*dx)/(2*g*4*rh[2]*As[2]*As[2]);	}
					else if(fmodell==2)
					{	Rs2=(fq(As[2],4*rh[2],QLs2[0][Is2])*dx)/(2*g*4*rh[2]*As[2]*As[2]);}
					else if(fmodell==3)
					{	Rs2=0;}

					Cps2=HLs2[0][Is2-1]+(Bs2*QLs2[0][Is2-1])-(g*Js2[0][Is2]);
					Bps2=Bs2+(Rs2*fabs(QLs2[0][Is2-1]));
					QLs2ny[0][Is2]=(Cps2-HLs2[0][Is2])/Bps2;
					HLs2ny[0][Is2]=HLs2[0][Is2]+((QLs2ny[0][Is2]/Asjakt[2])*dt);
					Z2=Z2+((QLs2ny[0][Is2]/Asjakt[2])*dt);

					if(fmodell==3)
					{	Js=(dx*fq(As[2],4*rh[2],QLs2[0][Is2])*QLs2[0][Is2]*QLs2[0][Is2])/(As[2]*As[2]*4*rh[2]*2*g*g);
						djdt=(1/Y)*	(((K/(g*As[2]))*(QLs2ny[0][Is2]-QLs2[0][Is2]))-Js2[0][Is2]+Js);
						Js2ny[0][Is2]=Js2[0][Is2]+(djdt*dt);
																							}
					else
					{	Js2ny[0][Is2]=0;}
				////////////////Slutt rr s2//////////////////////////
			}
	//---------------- Slutt node 9 med sving ---------------//

			//////////// Start Rr 8 /////////////
			for (i8=1;i8<I8;i8++)
			{	if(fmodell==1)
				{	R8=(f*dx)/(2*g*4*Rh[8]*A[8]*A[8]);	}
				else if(fmodell==2)
				{	R8=(fq(A[8],4*Rh[8],QL8[0][i8])*dx)/(2*g*4*Rh[8]*A[8]*A[8]);}
				else if(fmodell==3)
				{	R8=0;}

				Cp8=HL8[0][i8-1]+(B8*QL8[0][i8-1])-(g*J8[0][i8]);
				Bp8=B8+(R8*fabs(QL8[0][i8-1]));
				Cm8=HL8[0][i8+1]-(B8*QL8[0][i8+1])+(g*J8[0][i8]);
				Bm8=B8+(R8*fabs(QL8[0][i8+1]));
				HL8ny[0][i8]=( ((Cp8*Bm8)+(Cm8*Bp8)) / (Bp8+Bm8));
				QL8ny[0][i8]=( (Cp8-Cm8)/(Bp8+Bm8) );

				if(fmodell==3)
				{	Js=(dx*fq(A[8],4*Rh[8],QL8[0][i8])*QL8[0][i8]*QL8[0][i8])/(A[8]*A[8]*4*Rh[8]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[8]))*(QL8ny[0][i8]-QL8[0][i8]))-J8[0][i8]+Js);
					J8ny[0][i8]=J8[0][i8]+(djdt*dt);
																						}
				else
				{	J8ny[0][i8]=0;}
			}

			HL8ny[0][I8]=Hu;
			Cp8=HL8[0][I8-1]+(B8*QL8[0][I8-1])-(g*J8[0][I8]);
			Bp8=B8+(R8*fabs(QL8[0][I8-1]));
			QL8ny[0][I8]=(Cp8-HL8ny[0][I8])/Bp8;

				if(fmodell==3)
				{	Js=(dx*fq(A[8],4*Rh[8],QL8[0][I8])*QL8[0][I8]*QL8[0][I8])/(A[8]*A[8]*4*Rh[8]*2*g*g);
					djdt=(1/Y)*	(((K/(g*A[8]))*(QL8ny[0][I8]-QL8[0][I8]))-J8[0][I8]+Js);
					J8ny[0][I8]=J8[0][I8]+(djdt*dt);
																						}
				else
				{	J8ny[0][I8]=0;}
			//////////// Slutt Rr 8 /////////////

			////////////Oppdatering til neste tidssteg/////////////
						for (i1=0;i1<=I1;i1++)
						{	QL1[0][i1]=QL1ny[0][i1];
							QL1ny[0][i1]=0;
							HL1[0][i1]=HL1ny[0][i1];
							HL1ny[0][i1]=0;
							J1[0][i1]=J1ny[0][i1];
							J1ny[0][i1]=0;
																				}
						for (i2=0;i2<=I2;i2++)
						{
							QL2[0][i2]=QL2ny[0][i2];
							QL2ny[0][i2]=0;
							HL2[0][i2]=HL2ny[0][i2];
							HL2ny[0][i2]=0;
							J2[0][i2]=J2ny[0][i2];
							J2ny[0][i2]=0;
																				}
						for (i3=0;i3<=I3;i3++)
						{
							QL3[0][i3]=QL3ny[0][i3];
							QL3ny[0][i3]=0;
							HL3[0][i3]=HL3ny[0][i3];
							HL3ny[0][i3]=0;
							J3[0][i3]=J3ny[0][i3];
							J3ny[0][i3]=0;
																				}
						for (i4=0;i4<=I4;i4++)
						{
							QL4[0][i4]=QL4ny[0][i4];
							QL4ny[0][i4]=0;
							HL4[0][i4]=HL4ny[0][i4];
							HL4ny[0][i4]=0;
							J4[0][i4]=J4ny[0][i4];
							J4ny[0][i4]=0;
																				}

						for (i5=0;i5<=I5;i5++)
						{
							QL5[0][i5]=QL5ny[0][i5];
							QL5ny[0][i5]=0;
							HL5[0][i5]=HL5ny[0][i5];
							HL5ny[0][i5]=0;
							J5[0][i5]=J5ny[0][i5];
							J5ny[0][i5]=0;
																				}

						for (i6=0;i6<=I6;i6++)
						{
							QL6[0][i6]=QL6ny[0][i6];
							QL6ny[0][i6]=0;
							HL6[0][i6]=HL6ny[0][i6];
							HL6ny[0][i6]=0;
							J6[0][i6]=J6ny[0][i6];
							J6ny[0][i6]=0;
																				}

						for (i7=0;i7<=I7;i7++)
						{
							QL7[0][i7]=QL7ny[0][i7];
							QL7ny[0][i7]=0;
							HL7[0][i7]=HL7ny[0][i7];
							HL7ny[0][i7]=0;
							J7[0][i7]=J7ny[0][i7];
							J7ny[0][i7]=0;
																				}

						for (i8=0;i8<=I8;i8++)
						{
							QL8[0][i8]=QL8ny[0][i8];
							QL8ny[0][i8]=0;
							HL8[0][i8]=HL8ny[0][i8];
							HL8ny[0][i8]=0;
							J8[0][i8]=J8ny[0][i8];
							J8ny[0][i8]=0;
																				}

						for (i9=0;i9<=I9;i9++)
						{
							QL9[0][i9]=QL9ny[0][i9];
							QL9ny[0][i9]=0;
							HL9[0][i9]=HL9ny[0][i9];
							HL9ny[0][i9]=0;
							J9[0][i9]=J9ny[0][i9];
							J9ny[0][i9]=0;
																				}

						for (i10=0;i10<=I10;i10++)
						{
							QL10[0][i10]=QL10ny[0][i10];
							QL10ny[0][i10]=0;
							HL10[0][i10]=HL10ny[0][i10];
							HL10ny[0][i10]=0;
							J10[0][i10]=J10ny[0][i10];
							J10ny[0][i10]=0;
																				}

						for (i11=0;i11<=I11;i11++)
						{
							QL11[0][i11]=QL11ny[0][i11];
							QL11ny[0][i11]=0;
							HL11[0][i11]=HL11ny[0][i11];
							HL11ny[0][i11]=0;
							J11[0][i11]=J11ny[0][i11];
							J11ny[0][i11]=0;
																				}

						for (i12=0;i12<=I12;i12++)
						{
							QL12[0][i12]=QL12ny[0][i12];
							QL12ny[0][i12]=0;
							HL12[0][i12]=HL12ny[0][i12];
							HL12ny[0][i12]=0;
							J12[0][i12]=J12ny[0][i12];
							J12ny[0][i12]=0;
																				}

						for (is1=0;is1<=Is1;is1++)
						{
							QLs1[0][is1]=QLs1ny[0][is1];
							QLs1ny[0][is1]=0;
							HLs1[0][is1]=HLs1ny[0][is1];
							HLs1ny[0][is1]=0;
							Js1[0][is1]=Js1ny[0][is1];
							Js1ny[0][is1]=0;
																				}

						for (is2=0;is2<=Is2;is2++)
						{
							QLs2[0][is2]=QLs2ny[0][is2];
							QLs2ny[0][is2]=0;
							HLs2[0][is2]=HLs2ny[0][is2];
							HLs2ny[0][is2]=0;
							Js2[0][is2]=Js2ny[0][is2];
							Js2ny[0][is2]=0;
																				}

						for (is3=0;is3<=Is3;is3++)
						{
							QLs3[0][is3]=QLs3ny[0][is3];
							QLs3ny[0][is3]=0;
							HLs3[0][is3]=HLs3ny[0][is3];
							HLs3ny[0][is3]=0;
							Js3[0][is3]=Js3ny[0][is3];
							Js3ny[0][is3]=0;
																				}
						if(t<=100)
						{	fprintf(resultatH,"%f\t%f\n",j*dt,(HL5[0][I5]-Hu-Hturb));
							fprintf(resultatHp,"%f\t%f\n",j*dt,(HL6[0][0]-Hu-Hturb));	}
						fprintf(resultatQ,"%f\t%f\n",j*dt,QL5[0][I5]);
						fprintf(resultatZ1,"%f\t%f\n",j*dt,Z1);
						fprintf(resultatZ3,"%f\t%f\n",j*dt,Z3);
						fprintf(resultatZ2,"%f\t%f\n",j*dt,Z2);

						t=t+dt;
				///////////////////////////////////////////////////////////
}

				/************************Plotter***********************/

					/*Plotter resultatfilen via Gnuplot*/
					// Open a pipe to gnuplot
					FILE *GP = popen("c:\\gnuplot\\bin\\pgnuplot -persist","w");
																									//Sjekker om gnuplot finnes
					if (GP)
					{
						fprintf(GP, "set style data lines\n");
						fprintf(GP, "cd 'C:\\Users\\bruker\\Documents\\MinGW32\\KMmod'\n");

						fprintf(GP, "set term wxt 0\n set grid\n set ytics 2\n set auto y\n plot \"resultatQ.txt\" using 1:2 title 'Q'\n");
						if(S1==1 || S2==1)
						{	fprintf(GP, "set term wxt 1\n plot \"resultatZ1.txt\" using 1:2 title 'Z1'\n");	}
						else if(S3==1)
						{	fprintf(GP, "set term wxt 2\n plot \"resultatZ3.txt\" using 1:2 title 'Z1'\n");	}
						if(S4==1)
						{	fprintf(GP, "set term wxt 3\n plot \"resultatZ2.txt\" using 1:2 title 'Z2'\n");	}
						fprintf(GP, "set term wxt 4\n set ytics 2\n set xrange [0:60]\n set xlabel 'Tid'\n set ylabel 'Amplitude'\n plot \"resultatH.txt\" using 1:2 title 'H-'\n");	//Plotter resultat1.txt med kolonne 1 som x og 3 som y
						fprintf(GP, "set term wxt 5\n set yrange [0:1.2]\n  plot \"Kstil.txt\" using 1:2 title 'K'\n");
						fprintf(GP, "set term wxt 6\n set auto y\n plot \"resultatHp.txt\" using 1:2 title 'H-nedstrms'\n");

						fprintf(GP, "set terminal png enhanced size 1280,1024 fontscale 1.3\n set ytics 2\n set xrange [0:60]\n  set output 'Hturb.png'\n");			//Klargjr for laging av png-fil
						fprintf(GP, "plot \"resultatH.txt\" using 1:2 title 'H-' lw 2\n");															  							//Gir navn til png-fil og plotter p nytt til den
						if(S1==1 || S2==1)
						{	fprintf(GP, "set ytics 2\n set auto x\n set output 'Z1.png'\n");
							fprintf(GP, "plot \"resultatZ1.txt\" using 1:2 title 'Z1' lw 2\n");		}
						fprintf(GP, "set ytics 2\n set xrange [0:60]\n set output 'Hpluss.png'\n");
						fprintf(GP, "plot \"resultatHp.txt\" using 1:2 title 'H-nedstrms' lw 2\n");
						if(S3==1)
						{	fprintf(GP, "set ytics 2\n set auto x\n set output 'Z1.png'\n");
							fprintf(GP, "plot \"resultatZ3.txt\" using 1:2 title 'Z1' lw 2\n");	}
						if(S4==1)
						{	fprintf(GP, "set ytics 2\n set auto x\n set output 'Z2.png'\n");
							fprintf(GP, "plot \"resultatZ2.txt\" using 1:2 title 'Z2' lw 2\n");	}
						fflush(GP);
						fprintf(stderr,"Press enter to continue...");
						fflush(stderr);
						getchar();
							  																		// lukker gnuplot
						fprintf(GP,"exit \n");
					pclose(GP);		}


						fclose(resultatH);
						fclose(resultatQ);
						fclose(resultatZ1);
						fclose(resultatZ2);
						fclose(resultatZ3);
						fclose(Kstil);

return 0;
}