/*Dette skriptet tar inn inputdata og beregner rrlengder og rrfall*/

#include<stdbool.h>
#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#define g 9.82



float L[13],Ls[4],A[13],As[4],Rh[13],rh[4],Asjakt[4],DZ[10],dZ[3];


float L1,L2,L3,L4,L5,L6,L7,L8,L9,Ls1,Ls2,L10,Ls3,L11,L12;
float x1,Y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,x5,y5,z5,x6,y6,z6,x7;			//kooridnater for knutepunkter
float y7,z7,x8,y8,z8,x9,y9,z9,x10,y10,z10,xso,yso,zso,xsn,ysn,zsn;
float Aso,Asn,fmodell,sjakttyp,Qn,Q0,Q0bekk,a,Kstart,simtyp,tKstart,Tpadrag,Tl,Tavslag,dt,tmax,H0,Hturb,Hu;
float dx;
_Bool S1,S2,S3,S4,Bekk,FLsjakt;


int input(void)
{
	/*Inndata for IO-verdier*/
	FILE *inio;
	inio = fopen("IOinput.txt", "r");

	int IO[7], j;
	for (j=1; j<=6; j++)							//putter alle av-p-data i inputIO. Her slr man av og p svingekamre og bekkeinntak
		fscanf(inio, "%i", &IO[j]);

	S1=IO[1], S2=IO[2], S3=IO[3], S4=IO[4], Bekk=IO[5],FLsjakt=IO[6];


	if (Bekk+FLsjakt>1)
	{	printf("FEIL! BEKKEINNTAK OG FORLENGELSE TIL SJAKT KAN IKKE SLaS Pa SAMTIDIG!");
		exit(EXIT_FAILURE);}

	/*Inndata for lengder*/
		FILE *inL;
		inL = fopen("inputLengder.txt","r");

		float Li[16];
		int l;
		for (l=1; l<=15; l++)
			fscanf(inL, "%f", &Li[l]);

		L1=Li[1],L2=Li[2],L3=Li[3],L4=Li[4],L5=Li[5],L6=Li[6],L7=Li[7];
		L8=Li[8],L9=Li[9],L10=Li[10],L11=Li[11],L12=Li[12],Ls1=Li[13],Ls2=Li[14],Ls3=Li[15];



	/*Inndata for hydrauliske strrelser*/
	FILE *inhyd;
	inhyd = fopen("inputhydraulisk.txt", "r");

	float hyd[17];
	int k;
	for (k=1; k<=16; k++)
		fscanf(inhyd, "%f", &hyd[k]);

	fmodell=hyd[1], Q0=hyd[2], Qn=hyd[3], a=hyd[4], Kstart=hyd[5], tKstart=hyd[6],simtyp=hyd[7];
	Tpadrag=hyd[8], Tl=hyd[9], Tavslag=hyd[10], dt=hyd[11], tmax=hyd[12],H0=hyd[13],Hturb=hyd[14],Hu=hyd[15],Q0bekk=hyd[16];


	/*Inndata for kraftverkgeometri*/
	FILE *ingeo;
	ingeo = fopen("inputgeometri.txt","r");

	float geo[27];
	int i;
	for (i=1; i<=26; i++)
		fscanf(ingeo, "%f", &geo[i]);

	A[1]=geo[1],A[2]=geo[1],A[3]=geo[2],A[4]=geo[2],A[5]=geo[3],A[6]=geo[4],A[7]=geo[5],A[8]=geo[5],A[9]=geo[6];
	As[1]=geo[7],As[2]=geo[8],Rh[1]=geo[9],Rh[2]=geo[9],Rh[3]=geo[10],Rh[4]=geo[10];
	Rh[5]=geo[11],Rh[6]=geo[12],Rh[7]=geo[13],Rh[8]=geo[13],Rh[9]=geo[14],rh[1]=geo[15],rh[2]=geo[16],Asjakt[1]=geo[17],Asjakt[2]=geo[18];
	sjakttyp=geo[19],A[10]=geo[6],Rh[10]=geo[14],As[3]=geo[20],Asjakt[3]=geo[21],rh[3]=geo[22],A[11]=geo[23],A[12]=geo[24],Rh[11]=geo[25];
	Rh[12]=geo[26];

	dx=a*dt;
int q;
	for(q=1;q<=15;q++)
	{
		if(Li[q]<dx)
		{	Li[q]=dx;}
	}

	/*Alle lengder blir her endret slik at L/dx er et heltall*/

	L[1]= dx*roundf(Li[1]/dx);
	L[2]= dx*roundf(Li[2]/dx);
	L[3]= dx*roundf(Li[3]/dx);
	L[4]= dx*roundf(Li[4]/dx);
	L[5]= dx*roundf(Li[5]/dx);
	L[6]= dx*roundf(Li[6]/dx);
	L[7]= dx*roundf(Li[7]/dx);
	L[8]= dx*roundf(Li[8]/dx);
	L[9]= dx*roundf(Li[9]/dx);
	L[10]=dx*roundf(Li[10]/dx);
	L[11]=dx*roundf(Li[11]/dx);
	L[12]=dx*roundf(Li[12]/dx);
	Ls[1]= dx*roundf(Li[13]/dx);
	Ls[2]= dx*roundf(Li[14]/dx);
	Ls[3]= dx*roundf(Li[15]/dx);

fclose(inhyd);
fclose(ingeo);
fclose(inio);
//fclose(inkoord);
fclose(inL);

remove("Lkontroll.txt");
FILE *Lkontr;
Lkontr = fopen("Lkontroll.txt", "a");

for (i=1;i<=12;i++)
{
	fprintf(Lkontr,"Rr%i\t%f\n", i, L[i]);
}
fprintf(Lkontr,"RrS%i\t%f\n", 1, Ls[1]);
fprintf(Lkontr,"RrS%i\t%f\n", 2, Ls[2]);
fprintf(Lkontr,"RrS%i\t%f\n", 3, Ls[3]);

fclose(Lkontr);

return 0;
}

